*-- Author :    Hartwig Albrecht   21/05/95

      SUBROUTINE DDEXEC

************************************************************************
*
* Description: execute the data definition task
*
* Called from: KAEXEC
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZDDCOM.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER L

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      IF (JDDEF .EQ. 0)  CALL MMBOOK (JDDEF, 0)

C end of users DD commands

      NDDUSR = NDDEF()

C Make drelat commands

      CALL DDRELA

C end of new DD commands

      NDDNEW = NDDEF()

C read DD commands from kumac

      C78 = 'EXEC '
      CALL CH78BC (HBDIRV)
      CALL CH78AC ('/dd/auto.inc/all')
      CALL MEWARC (35648, 'DDEXEC: ' // C78)
      CALL KUEXEC (C78)

C check syntax

      CALL DDCHCK

C reference dd file:

      CALL DDOPEN ('all', 'kumac')
      CALL MEWARC (35475, '(this file is the reference dd file;')
      CALL MEWARC (76135, 'important for public libraries;')
      CALL MEWARC (34567, 'can be deleted on private directories)')

      DO L = 1, NDDEF()
        IF (IDDEF_FLAG(L) .GE. LDDEF_INI)  CALL LIDDE1 (LDDEF, L)
      END DO

      CALL IOCLOS (LDDEF)

      NDDCRD = 1
      NDDIND = 1

C write include directory

      CALL DDATTF
      CALL DDATTC
C C++: old and new style:
      CALL DDATCP
c      CALL DDATCC

      CALL DDMENF
      CALL DDMENC

      CALL DDHELP
      CALL DDTABL

      CALL DDNAMF
      CALL DDNAMC

      END

************************************************************************
* End of DDEXEC
************************************************************************
