//                              -*- Mode: C++ -*-
//:ECDcalIO.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 9/4/97
// Last Update ........
//

#include "care/ECDcalIO.hh"
#undef WRITE

/*
CLASS
  ECDcalIO


*/

// -------------------------------
ECDcalIO::ECDcalIO() :  dcalbank(0), fedblock(0), data(0) , 
  nchar(0), lenght(0){}

void ECDcalIO::start(EcalEvent_t * event){
  if(event!=0){
    dcalbank = (unsigned char*) event;
  } else {
    dcalbank = (unsigned char*)&(ArtePointer<DCAL>(1)->bits[0]);
  }
  fedblock = 0;
  data = 0;
  nchar = 0;
  lenght = ArtePointer<DCAL>::nrow()*4;
}

void ECDcalIO::start(){
  dcalbank = (unsigned char*)&(ArtePointer<DCAL>(1)->bits[0]);
  fedblock = 0;
  data = 0;
  nchar = 0;
  lenght = ArtePointer<DCAL>::nrow()*4;
}

