#ifndef _MIMP_HH_
#define _MIMP_HH_
struct MIMP_DIGB;
struct MIMP_HITB;
struct MIMP {
   float z;
   float x;
   float y;
   float tx;
   float ty;
   float p;
   float time;
   int gede;
   ArtePointer<MTRA> mtra;
   ArteRelationPointer<MIMP_DIGB> digb;
   ArteRelationPointer<MIMP_HITB> hitb;
};
#include "auto/MTRA.hh"
#include "auto/MTMI.hh"
#include "auto/DIGB.hh"
#include "auto/MIDI.hh"
#include "auto/HITB.hh"
#include "auto/MIHI.hh"
#include "auto/MIMP.icc"
#endif
