
      SUBROUTINE GUROT(IROT,POLD,PNEW)

************************************************************************
*
* written by Siegmund Nowak, Oct.30.1997
*
* This routines rotates a point POLD from the master system to the
* system given by geant Matrix IROT. 
*
*       called from everywhere
*
* Arguments  kind         description
*-----------------------------------------------------------------------
* IROT        in           Number of geant matrix
* POLD        in           Point in Master system
* PNEW        out          Point in rotated system
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
      INTEGER IROT,JR
      REAL POLD(3), PNEW(3) 
#include "arte/Arte.ff"

      IF(IROT.EQ.0) THEN
         PNEW(1) = POLD(1) 
         PNEW(2) = POLD(2)
         PNEW(3) = POLD(3) 
      ELSE 
         JR = LQ(JROTM-IROT)
         PNEW(1) = Q(JR+1)*POLD(1) + Q(JR+4)*POLD(2) + Q(JR+7)*POLD(3) 
         PNEW(2) = Q(JR+2)*POLD(1) + Q(JR+5)*POLD(2) + Q(JR+8)*POLD(3) 
         PNEW(3) = Q(JR+3)*POLD(1) + Q(JR+6)*POLD(2) + Q(JR+9)*POLD(3) 
      ENDIF
      END
