*CMZ :          12/09/96  21.16.55  by  Fedor Ratnikov
*CMZ :  1.01/02 01/02/96  15.12.31  by  Fedor Ratnikov
*CMZ :  1.00/08 03/12/95  11.58.14  by  Fedor Ratnikov
*CMZ :  1.00/07 06/11/95  11.11.33  by  Fouzia SAADI
*CMZ :  1.00/06 28/09/95  16.54.46  by   Ivan Belyaev
*CMZ :  1.00/01 10/08/95  00.10.14  by  S.B.
*CMZ :  1.00/00 22/02/95  19.42.31  by  Fedor Ratnikov
*CMZ :  0.01/03 17/09/94  17.50.07  by  Fedor Ratnikov
*CMZ :  0.01/02 07/09/94  19.40.09  by  Fedor Ratnikov
*CMZ :  0.01/01 24/07/94  13.50.19  by  Dominik Ressing
*-- Author :    Dominik Ressing   21/07/94
*************************************************************************
* L1KEYRD
* written by Dominik Ressing, 21/07/94 15.46.33
*
* This routines action:
* Reads the keys from the file l1keyfil defined in L1PARAM into memory
*
*
*
************************************************************************c
      SUBROUTINE L1KEYRD
c
      IMPLICIT NONE
#include "l1si/cfread.fi"
#include "arte/Arte.fi"
#include "auto/MEIO.fi"
#include "l1si/l1param.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1mcuda.fi"
#include "l1si/l1detuse.fi"
#include "l1si/l1detmu.fi"
#include "l1si/l1hbook.fi"
#include "l1si/l1kuip.fi"
c
      INTEGER IDUM,iostat
c
c
      CHARACTER*200 cfname
      CHARACTER*6 CIDENT
      INTEGER i,ierr,ipnt
C
C PRESETTING OF MUON PRETRIGGER ARRAYS
C
      CHARACTER CMUPRE*4

      DIMENSION CMUPRE(L1NUMpret)

      INTEGER IOLUN
c      PARAMETER (IOLUN=41)


      DATA CMUPRE /'MUD3','MUD4','MXD3','MXD4' /



C
C THE  VERY PRESETTING
C
C
      CALL UCOPY(CMUPRE(1),C1NamePret(1),L1NUMpret)
c
c
C---             Initialize L1SIMU dat input


      IOLUN = LREAD
c      CALL IODECL(IOLUN,'L1DAT','L1SIMU data cards')
      CALL IFOPEN(IOLUN,l1k_datafile,'FO',0,ierr,ipnt)

      CALL FFINIT(2000)

c
      CALL FFINIT(nFFREAD)              ! clear all stored keys
      CALL FFSET('LINP',IOLUN)          ! set logical unit number for key-file
      CALL FFSET('LOUT',L1LUNprn)      ! set log. unit number for FFREAD output
      CALL FFSET('SIZE',6)             ! only 6 characters of a key are significant
c
c     ---  Tuples to be filled
c      CALL VZERO(L1NtupID(1),L1NtupMax)
c      CALL FFKEY('NTUP',L1NtupID(1),L1NtupMax,'INTEGER')
      do i=1,MIN(L1NtupMax,l1k_nntuple)
       L1NtupID(i) = l1k_ntuple(i)
      enddo
c     --- print level
c      L1PARprnlev = 0
c      CALL FFKEY('PRNLEV',L1PARprnlev,1,'INTEGER')
      L1PARprnlev = l1k_prnlev
c     --- ECAL threshold parameter Ktrig
c      T1DEFktrig = 500.
c      CALL FFKEY('EKTRIG',T1DEFktrig,1,'REAL')
      T1DEFktrig = t1k_ektrig
c     --- fraction of cell size used in COG prediction
c      T1DEFcogfra = 1.
c      CALL FFKEY('COGFRA',T1DEFcogfra,1,'REAL')
      T1DEFcogfra = t1k_cogfra
c
c New (TRUE) or old (FALSE) input bank configuration
c
c      L1DEFnewold = .FALSE.
c      CALL FFKEY('CALONG',L1DEFnewold,1,'LOGICAL')
      L1DEFnewold = l1k_calong
c
C     --- define up to L1MCUmaxtriggers triggers (keys TRI001,TRI002, ... )
      DO i=1,L1MCUmaxtriggers

c         WRITE(CIDENT,'(''TRI'',I3.3)') i

c         T1MCUtrig( L1MCUtri1lowPT  , i ) =     0.50
c         T1MCUtrig( L1MCUtri1highPT , i ) =    10.00
c         T1MCUtrig( L1MCUtri2lowPT  , i ) =     0.50
c         T1MCUtrig( L1MCUtri2highPT , i ) =    10.00
c         T1MCUtrig( L1MCUtri1lowP   , i ) =     5.00
c         T1MCUtrig( L1MCUtri1highP  , i ) = 10000.00
c         T1MCUtrig( L1MCUtri2lowP   , i ) =     5.00
c         T1MCUtrig( L1MCUtri2highP  , i ) = 10000.00
c         T1MCUtrig( L1MCUtriEasym   , i ) =     1.00

c         CALL FFKEY(CIDENT,L1MCUtrig(1,i),
c     &        L1MCUtrireadlength,'MIXED')
       
       if(i.le.l1k_ntriggers)   then
        call ucopy(t1k_trigger(i_l1k_type1,i),
     &       T1MCUtrig(L1MCUtrictype1,i),l1k_trigfields)
       else
        C1MCUtrig(L1MCUtrictype1,i) = C1MCUdummy
       endif
      END DO



c     --- level of detail
      L1PARdetail = 0
      CALL FFKEY('DETAIL',L1PARdetail,1,'INTEGER')
c     --- pile up or single event
      L1PARpileup = .false.
      CALL FFKEY('PILEUP',L1PARpileup,1,'LOGICAL')
c     --- noraml data read or enter events by hand
      L1PARhandev = 0
      CALL FFKEY('HANDEV',L1PARhandev,1,'INTEGER')
c     --- time for message sending
      CALL FFKEY('MESTIM',L1DEFmestim,2,'INTEGER')
c
c     --- MSG, MU and PIX ORing
      L1DETmsgOR = 4
      CALL FFKEY('MSGORD',L1DETmsgOR,1,'INTEGER')
      L1DETpxOR = 4
      CALL FFKEY('PIXORD',L1DETpxOR,1,'INTEGER')
      L1DETmupxor = 6
      CALL FFKEY('MUPORD',L1DETmupxor,1,'INTEGER')
      CALL VFILL(L1DETmuOR,4,1)
      CALL FFKEY('MUORD',L1DETmuOR,4,'INTEGER')
c     --- shower max positions in ECAL relative to module begining
      T1DEFzecal(1) = 15.4
      T1DEFzecal(2) = 15.4
      T1DEFzecal(3) = 6.5
      CALL FFKEY('ECALSM',T1DEFzecal,3,'REAL')
c     --- Transverse energy cut for photon trigger
      T1DEFgamath = 3.
      CALL FFKEY('GAMATH',T1DEFgamath,1,'REAL')
c     --- ECAL threshold stops growing inside this radius
      T1DEFRmin = 10.
      CALL FFKEY('EKRMIN',T1DEFRmin,1,'REAL')
c     --- treshold fraction accepted for statistics
      T1DEFBremKfrac = 0.0  ! default: no threshold
      CALL FFKEY('BREFRA',T1DEFBremKfrac,1,'REAL')
c     --- safety factor fo E-P comparison
      T1DEFepfrac = 1.5
      CALL FFKEY('EPFRAC',T1DEFepfrac,1,'REAL')
c     --- ECAL energy resolution parameters
      T1DEFstares(1) = 0.   ! outer
      T1DEFstares(2) = 0.   ! middle
      T1DEFstares(3) = 0.   ! inner
      CALL FFKEY('ERESTA',T1DEFstares,3,'REAL')
      T1DEFconres(1) = 0.   ! outer
      T1DEFconres(2) = 0.   ! middle
      T1DEFconres(3) = 0.   ! inner
      CALL FFKEY('ERECON',T1DEFconres,3,'REAL')
c     --- ECAL COG correction parameters
      T1DEF1cogcor(1) = 3.6
      T1DEF1cogcor(2) = 1.8
      T1DEF1cogcor(3) = 0.75
      CALL FFKEY('COG1',T1DEF1cogcor,3,'REAL')
      T1DEF2cogcor(1) = 2.5
      T1DEF2cogcor(2) = 3.5
      T1DEF2cogcor(3) = 9.
      CALL FFKEY('COG2',T1DEF2cogcor,3,'REAL')
c     --- Electronic card X & Y size
      L1DEFcardXsize(1) = 8
      L1DEFcardYsize(1) = 6     ! Outer: 8x6
      L1DEFcardXsize(2) = 4
      L1DEFcardYsize(2) = 3     ! Middle: 4x3
      L1DEFcardXsize(3) = 2
      L1DEFcardYsize(3) = 1     ! Inner: 2x1
      CALL FFKEY('ECXSIZ',L1DEFcardXsize,3,'INTEGER')
      CALL FFKEY('ECYSIZ',L1DEFcardXsize,3,'INTEGER')
c     --- Electronic card X & Y position (shift from 0)
      L1DEFcardXshift(1) = 4
      L1DEFcardYshift(1) = 3     ! Outer
      L1DEFcardXshift(2) = 0
      L1DEFcardYshift(2) = 0     ! Middle
      L1DEFcardXshift(3) = 1
      L1DEFcardYshift(3) = 0     ! Inner
      CALL FFKEY('ECDXSH',L1DEFcardXshift,3,'INTEGER')
      CALL FFKEY('ECDYSH',L1DEFcardXshift,3,'INTEGER')
c     --- Electronic card brem recovery
      L1DEFbremDiff(1) = 1
      L1DEFbremDiff(2) = 1
      L1DEFbremDiff(3) = 1
      CALL FFKEY('ECBREC',L1DEFbremDiff,3,'INTEGER')
c     --- Electronic card overlap
      L1DEFcardOvlp = 1
      CALL FFKEY('ECOVLP',L1DEFcardOvlp,1,'INTEGER')
c
c     --- minimal momentum used
      T1DEFmommin = 5.
      CALL FFKEY('MOMMIN',T1DEFmommin,1,'REAL')
c     --- splitting of ROI due to the 2 possible track charges.
      T1DEFroiDisMin = 0.   ! split all seperated ROI
      CALL FFKEY('ROIDIS',T1DEFroiDisMin,1,'REAL')
      T1DEFroiSloMax = 0.05 ! split only if nominal slope differes less than 50mrad
      CALL FFKEY('ROISLO',T1DEFroiSloMax,1,'REAL')
c     --- maximal number of neighbouring detector cells ORed
      L1DEFNeiOrMax = 9999
      CALL FFKEY('NEIORM',L1DEFNeiOrMax,1,'INTEGER')
c
C     --- define up to L1DEFmaxpre Pretriggerss ( keys PRE001,PRE002 ... )
      DO i=1,L1DEFmaxpre
         WRITE(CIDENT,'(''PRE'',I3.3)') i
         CALL FFKEY(CIDENT,L1DEFpredef(L1PREdef,i),
     &        L1DEFprelen+1-L1PREdef,'MIXED')
      END DO
c     --- time needed for Pretriggers
      CALL FFKEY('MUOTIM',L1DEFmuotim,1,'INTEGER')
      CALL FFKEY('CALTIM',L1DEFcaltim,1,'INTEGER')
      CALL FFKEY('HPTTIM',L1DEFhpttim,1,'INTEGER')
c
c     Rejection of messages dublicates in MCU
c
      L1PARdltdbl = 0 ! Default: do not reject
      CALL FFKEY('DREJECT',L1PARdltdbl,1,'INTEGER')
      T1PARmcuPPdiff   = 0.
      CALL FFKEY('PDIFF',T1PARmcuPPdiff,1,'REAL')



c
c Muon information
c (number of sections in one layer)
      CALL FFKEY('MUSECT',L1DEFmuosec(1),L1DEFMuSl,'INTEGER')

c
c Muon superlayers used in pretrigger
c
c
      CALL FFKEY('MUPRE',C1NamePret(1),L1NUMpret,'CHARACTER')
c
c Number of connections between pads in outer part of muon
c chambers
c
      CALL FFKEY('MUCON',L1DEFmuocon,1,'INTEGER')
c
c Algorythm numbers for multiple scattering calculation
c for muon superlayers
c
      L1MUMSCpar(1)=1
      L1MUMSCpar(2)=1
      L1MUMSCpar(3)=1
      CALL FFKEY('MUNUM',L1MUMSCpar,L1MUpredsup,'INTEGER')
c
c X- and Y- intervals ( measured in  SIGMA values )
c
      T1MUXMSCpar(1)=3.
      T1MUXMSCpar(2)=3.
      T1MUXMSCpar(3)=3.
      CALL FFKEY('XMSCA',T1MUXMSCpar,L1MUpredsup,'REAL')

      T1MUYMSCpar(1)=3.
      T1MUYMSCpar(2)=3.
      T1MUYMSCpar(3)=3.
      CALL FFKEY('YMSCA',T1MUYMSCpar,L1MUpredsup,'REAL')

c
c Cut on pcut=pcut(r) at small P ( <=> large R )
c
      T1MUTHRpar(1)=3.
      T1MUTHRpar(2)=5.
      T1MUTHRpar(3)=5.
      CALL FFKEY('MUTHR',T1MUTHRpar,L1MUpredsup,'REAL')
c
c     TRD information
c
      L1TRDSL = 0  ! TRD TVU is called before this SL TFU processing
      CALL FFKEY('TRDSL',L1TRDSL,1,'INTEGER')

c
c     --- define names for detectors used in this study
c
      DO i=1,L1maxDetUsed
        c1DetUsed(i) = C1MCUdummy
      ENDDO
      CALL FFKEY('USEDET',c1DetUsed(1),L1maxDetUsed,'CHARACTER')
c
C     --- define up to L1DEFmaxtfu TFUs (keys TFU001,TFU002, ... )
      DO i=1,L1DEFmaxtfu
         WRITE(CIDENT,'(''TFU'',I3.3)') i
         CALL FFKEY(CIDENT,L1DEFtfudef(L1TFUdef,i),
     &        L1DEFtfulen+1-L1TFUdef,'MIXED')
      END DO
c     --- cycle time for TFUs
      CALL FFKEY('TFUCYC',L1DEFtfucyc,2,'INTEGER')
c     --- width and height for TFU matrix
      CALL FFKEY('TFUSIZ',L1DEFtfuMxWid,2,'INTEGER')
c
C     --- define up to L1DEFmaxtpm TPMs (keys TPM001,TPM002, ... )
      DO i=1,L1DEFmaxtpm
         WRITE(CIDENT,'(''TPM'',I3.3)') i
         CALL FFKEY(CIDENT,L1DEFtpmdef(L1TPMdef,i),
     &        L1DEFtpmlen+1-L1TPMdef,'MIXED')
      END DO
c     --- cycle time for TPMs
      CALL FFKEY('TPMCYC',L1DEFtpmcyc,2,'INTEGER')
c
c     --- we have to read in 2 portions to keep memory limit
c
c      CALL FFGO
c      CALL FFINIT(FFSIZE)         ! clear all stored keys
c      CALL FFSET('LINP',L1KEYlun) ! set logical unit number for key-file
c      CALL FFSET('LOUT',L1LUNprn) ! set log. unit number for FFREAD output
c      CALL FFSET('SIZE',6)        ! only 6 characters of a key are significant
c
C     --- define up to L1DEFmaxmcu MCUs (keys MCU001,MCU002, ... )
      DO i=1,L1DEFmaxmcu
         WRITE(CIDENT,'(''MCU'',I3.3)') i
         CALL FFKEY(CIDENT,L1DEFmcudef(L1MCUdef,i),
     &        L1DEFmculen+1-L1MCUdef,'MIXED')
      END DO
c     --- cycle time for MCUs
      CALL FFKEY('MCUCYC',L1DEFmcucyc,2,'INTEGER')
c
c
C     --- define the 4 TEBs (test boards)
      CALL FFKEY('TEBPRE',L1TEBconPREnum,L1DEFteblen,'INTEGER')
      CALL FFKEY('TEBTFU',L1TEBconTFUnum,L1DEFteblen,'INTEGER')
      CALL FFKEY('TEBTPM',L1TEBconTPMnum,L1DEFteblen,'INTEGER')
      CALL FFKEY('TEBMCU',L1TEBconMCUnum,L1DEFteblen,'INTEGER')
c
c
c     --- read keys and write contents to commons
      CALL FFGO
      CALL IOCLOS(IOLUN)
c
      RETURN
c
      END
