
* B.Fominykh  20.05.99
* the program of MUREC-B package
* make seeds to start the muon reconstruction
* RSEG table is used as a source
C
      SUBROUTINE MURSDIN
C-    ==================
      IMPLICIT NONE
      INTEGER IR,JR,JRR,NS,JS,IMC,JMC,I,J,ISL,JSL
      INTEGER JSHM,NML,NHTC1,NHTC2,ICHK
      INTEGER IRC,JAUX,IRUN,IPSG,ID
      REAL P,PM,PX,PY,PZ,SIGEXT,FRACMC
      REAL X1,X2,Y1,Y2,Z1,Z2,Z0,CX,CY,TX,TY,XE,YE
*
*     **** packing scheme for covariance
      integer matrix_pack(5,5)
      data matrix_pack
     +     / 1,  2,  4,  7, 11,
     +       2,  3,  5,  8, 12,
     +       4,  5,  6,  9, 13,
     +       7,  8,  9, 10, 14,
     +      11, 12, 13, 14, 15 /
      save matrix_pack
*
#include "murec/MUCBTAB.fi"
      REAL PSD(NSDMXP)
      INTEGER LPSEG(NSDMXP)
#include "murec/MUCBPAR.fi"
#include "murec/MUCBZDT.fi"
#include "arte/Arte.fi"
#include "arte/RSEG_cmp.fi"
#include "auto/GEO.fi"
#include "auto/MC.fi"
#include "auto/RSEG.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MC.ff"
#include "auto/RSEG.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
* no reconstructed tracks - nothing to do
      IF(JRSEG.LE.0)       GOTO 200
      IF(IQ(JRSEG+2).LE.0) GOTO 200
* size of first muon superlayer
      JSL=JGESL+2
      DO ISL=1,IQ(JGESL+2)
        IF(IQ(JSL+JGESL_CMP).EQ.8) THEN
          X1=Q(JSL+JGESL_X1)
          X2=Q(JSL+JGESL_X2)
          Y1=Q(JSL+JGESL_Y1)
          Y2=Q(JSL+JGESL_Y2)
          Z1=Q(JSL+JGESL_Z1)
          Z2=Q(JSL+JGESL_Z2)
          GOTO 5
        ELSE
          JSL=JSL+IQ(JGESL+1)
        ENDIF
      ENDDO
  5   CONTINUE
* 2 loops over RSEG segments - look for rsegc_bit6, then for rsegc_patt
      DO IRC=1,NSDMXP
        LPSEG(IRC)=0
      ENDDO
      NS=0
      DO 150 IRC=1,2*IQ(JRSEG+2)
        IF(IRC.LE.IQ(JRSEG+2)) THEN
          IRUN=1
          IR=IRC
        ENDIF
        IF(IRC.GT.IQ(JRSEG+2).AND.IRC.LE.2*IQ(JRSEG+2)) THEN
          IRUN=2
          IR=IRC-IQ(JRSEG+2)
        ENDIF
        JR=JRSEG+IQ(JRSEG+1)*(IR-1)+2
* not take the parent segments of IRUN=1 seeds
        IF(IRUN.EQ.2.AND.LPSEG(IR).GT.0) GOTO 150
* not take the killed segments
        IF(IAND(irseg_cmp(IR),rsegc_bitsign).NE.0) GOTO 150
* check cmp
        IF(IRUN.EQ.1.AND.
     +    (IAND(irseg_cmp(IR),rsegc_bit6).NE.0)) GOTO 30
        IF(IRUN.EQ.2.AND.
     +    (IAND(irseg_cmp(IR),rsegc_magt).NE.0).AND.
     +    (IAND(irseg_cmp(IR),rsegc_patt).NE.0)) GOTO 30
        GOTO 150
 30     CONTINUE

* CHECK-POINT: cut on  momentum
        PM=250.
        IF(ABS(Q(JR+JRSEG_PE)).GT.0.004) PM=1./ABS(Q(JR+JRSEG_PE))
        IF(PM.LT.PSDCUT) GOTO 150

* momentum distribution of tracks reconstructed in tracker 
        CALL HFILL(1040,PM,0.,1.)
* related MC track
        CALL TFREMCSE(IR,IMC,FRACMC)        
        JMC=JMTRA+IQ(JMTRA+1)*(IMC-1)+2
        ID = IQ(JMC+JMTRA_TOPP)
* muons
        IF(ID.EQ.22.OR.ID.EQ.23) CALL HFILL(1041,PM,0.,1.)
* hadrons
        IF(ID.GT.99) CALL HFILL(1042,PM,0.,1.)


* CHECK-POINT: impact point inside first muon superlayer
        Z0 = Q(JR+JRSEG_ZE)
        CX = Q(JR+JRSEG_XE)
        TX = Q(JR+JRSEG_TXE)
        XE = TX*(Z2-Z0)+CX
        IF(XE.LT.X1.OR.XE.GT.X2) GOTO 150
        CY = Q(JR+JRSEG_YE)
        TY = Q(JR+JRSEG_TYE)
        YE = TY*(Z2-Z0)+CY
        IF(YE.LT.Y1.OR.YE.GT.Y2) GOTO 150

* save the track as a seed
        NS=NS+1
* use relations to make the list of the IRUN=1 parent segments
        IF(IRUN.EQ.1) THEN
          JAUX=PRSEG_RBEG(IR)
          IF(JAUX.GT.0) THEN
            IPSG=MRSEG_RBEG(JAUX)
            IF(IPSG.GT.0.AND.IPSG.LE.IQ(JRSEG+2)
     +      .AND.IPSG.LE.NSDMXP) THEN 
              LPSEG(IPSG)=IR
            ENDIF 
          ENDIF 
        ENDIF 

        IF(NS.GT.IQ(JTMP6+2)) CALL MMBOOK(JTMP6,1)
        JS=JTMP6+IQ(JTMP6+1)*(NS-1)+2
        IQ(JS+1) = 0
        IQ(JS+2) = 0
        IQ(JS+3) = IR
        Q(JS+4) = PM
* start Z coordinate
        Q(JS+44) = Q(JR+JRSEG_ZF)
* an array for order
        ISDORD(NS)=NS
        PSD(NS)=PM
        IF(Q(JS+44).GT.500.)  PSD(NS)=PM/1000.
* track parameters at the end of track
        Q(JS+5) = Z0
        Q(JS+6) = CX
        Q(JS+7) = CY
        Q(JS+8) = TX
        Q(JS+9) = TY
* covariance
        JRR=JR+JRSEG_CVE-1
        DO I=1,4
          DO J=1,4
            Q(JS+4*I+J+5) = Q(JRR+matrix_pack(I,J))
          ENDDO
        ENDDO

* errors of multiple scattering and momenta inside superlayers
        CALL MURMSCB(NS)
* kill the stopped tracks
        DO I=1,4
          IF(Q(JS+32+I).LE.0.001) GOTO 149
        ENDDO
* predicted hit-map
        DO I=1,12
          IQ(JS+I+44)=0
        ENDDO
        CALL MURSHM(NS)
        JSHM=JS+44
* hit-map control
        NML=0
        DO I=1,12
          IF(IQ(JSHM+I).GT.0) NML=NML+1
        ENDDO
        IF(NML.LT.3) GOTO 149
*
* relation to MC track
        IQ(JS+37) = 0
        IQ(JS+38) = 0
        DO J=39,42
          Q(JS+J) = 0.
        ENDDO
        IF(MCFLAG.NE.1) GOTO 150
* related MC track
        CALL TFREMCSE(IR,IMC,FRACMC)        
* MC-track number
        IQ(JS+37) = IMC
        JMC=JMTRA+IQ(JMTRA+1)*(IMC-1)+2
* ID of MC-track
        IQ(JS+38) = IQ(JMC+JMTRA_TOPP)
* MC-track momentum
        PX=Q(JMC+JMTRA_PX)
        PY=Q(JMC+JMTRA_PY)
        PZ=Q(JMC+JMTRA_PZ)
        P=SQRT(PX*PX+PY*PY+PZ*PZ)
        Q(JS+39) = P
        Q(JS+40) = PX
        Q(JS+41) = PY
        Q(JS+42) = PZ
        GOTO 150
*
 149    CONTINUE
        NS=NS-1
 150  CONTINUE
* sort the seeds using momenta
      IF(NS.GT.1) CALL SORTZV(PSD,ISDORD,NS,1,1,0)
      DO 160 J=1,NS
        JS=JTMP6+IQ(JTMP6+1)*(ISDORD(J)-1)+2
        IQ(JS+43) = J
 160  CONTINUE
*
 200  CONTINUE
      RETURN
      END


