*-- Author :    Rainer Mankel   15/05/95

      integer function tumchit(ih)

*     **** return MC track number which caused hit ih
*     **** (=0) if several associated MC tracks

      implicit none
      integer ih, mimp, jaux1, jaux2
#include "arte/Arte.fi"

#include "auto/MIMP.fi"
#include "auto/HITB.fi"
#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/HITB.ff"


      mimp = 0

*     **** check if sensible hit
      if (ih.gt.iq(jhitb+2)) then
       print *,' () tumchit: invalid ih=', ih,
     +         ' #hits=', iq(jhitb+2)
       stop 'tumchit'
      endif

*     **** get related MIMPs
      jaux1 = phitb_mimp(ih)
      if (jaux1.eq.0) then
       tumchit = 0  ! no related MC particle
      else
       jaux2 = xhitb_mimp(jaux1) ! try to get second MC particle
       if (jaux2.eq.0) then
        mimp = mhitb_mimp(jaux1) ! get mimp
        if (mimp.gt.0.and.mimp.le.iq(jmimp+2)) then
         tumchit = omimp_mtra(mimp)
        else
         tumchit = 0
        endif
       else
        tumchit = 0
       endif
      endif
      end








