// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerScatThick
// calculate covariance matrix elements for multiple scattering


#ifndef rangerScatThick_HH
#define rangerScatThick_HH


#include "rang/ScatThin.hh"

class rangerScatThick : public  rangerScatThin {

public:
  rangerScatThick(double msEff, double Qp, double Tx, double Ty,
			 double d);
  void myList();
  double cXX;
  double cXY;
  double cYY;
  double cXTx;
  double cXTy;
  double cYTx;
  double cYTy;
};

//include "rang/ScatThick.icc"

#endif
