// 
//  Author:  Rainer Mankel                     Created:  02-Feb-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
#include "rang/rginit.hh"
#include "rang/zfpar.hh"

extern "C" {
  void tfevnt_();
}


extern "C" {
  void rgmaintr_() {

    // user routine main tracker reconstruction

    rginit_();

    int rLevel = zfpar_.rlevel;
    int fitLevel = zfpar_.fit;
    int segStor = zfpar_.segstor;

    zfpar_.rlevel = 4;
    zfpar_.segstor = 1;
    zfpar_.fit = 0;

    tfevnt_();

    zfpar_.rlevel = rLevel;
    zfpar_.fit = fitLevel;
    zfpar_.segstor = segStor;

  }
}
