// 
//  Author:  Rainer Mankel                     Created:  25-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/Domain.hh"
#include "rang/DomWin.hh"
#include "rang/DomObj.hh"
#include "rang/XPro.hh"
#include "rang/XWin.hh"

extern rangerDomObj* rangerDO;   // global DO pointer

extern "C" {
  void rgxprofi_(rangerDomain*& dom,rangerDomWin*& win,
		float& z,double& x,double& tx) {
//     cout << "rgxprofi: z=" << z 
// 	 << " x=" << x
// 	 << " tx=" << tx
// 	 << "dump window/domain " << endl;
//     win->dump();
//     dom->dump();
    rangerDO->xpro()->xWinFill(dom,win,z,x,tx);
//     cout << " ...........rgxprofi fill is done" << endl;
  }
}
