*-- Author :    Rainer Mankel   16/07/96

      subroutine tfkfpar()

*     **** set ranger parameters in /zfpar/
      implicit none
#include "rang/zfpar.fi"
      integer dlevel,rlevel,smooth,niter,nch,msmode,max_plpick,maxflt_x,
     +     maxflt_y,maxflt_mag,maxflt_3d,rmax_x,rmax_y,minmimp_pref,
     +     nhmin_y,navmode
      real whitmin_x,whitmin_y,whitmin_3d,whitmin_mag,f_moliere,
     +     cxxrf,cyyrf,ctxtxrf,ctytyrf,cqqrf,qplimit,zmin_ec,zmax_ec,
     +     zmin_mag,zmax_mag,qmin_x,qmin_y
      character*10 chopt,segstor,clmimp_pref,cdgsel

      call rginit()  ! make sure parameter defaults are set

      call kugeti(dlevel)
      call kugeti(rlevel)
      call kugeti(smooth)
      call kugeti(niter)
      call kugeti(msmode)
      call kugeti(max_plpick)
      call kugeti(maxflt_x)
      call kugeti(maxflt_y)
      call kugeti(maxflt_mag)
      call kugeti(maxflt_3d)
      call kugeti(rmax_x)
      call kugeti(rmax_y)
      call kugeti(minmimp_pref)

      call kugetr(whitmin_x)
      call kugetr(whitmin_y)
      call kugetr(whitmin_3d)
      call kugetr(whitmin_mag)
      call kugetr(f_moliere)
      call kugetr(cxxrf)
      call kugetr(cyyrf)
      call kugetr(ctxtxrf)
      call kugetr(ctytyrf)
      call kugetr(cqqrf)
      call kugetr(qplimit)
      call kugetr(zmin_ec)
      call kugetr(zmax_ec)
      call kugetr(zmin_mag)
      call kugetr(zmax_mag)
      call kugetc(segstor,nch)
      call kugetc(clmimp_pref,nch)
      call kugetr(qmin_x)
      call kugetr(qmin_y)
      call kugeti(nhmin_y)
      call kugetc(cdgsel,nch)
      call kugeti(navmode)
      call kugetc(chopt,nch)

      if (dlevel.gt.-99)   dlevel_zfpar  = dlevel
      if (rlevel.gt.-99)   rlevel_zfpar  = rlevel
      if (smooth.gt.-99)   smooth_zfpar  = smooth
      if (niter.gt.-99)    niter_zfpar = niter
      if (msmode.gt.-99)   msmode_zfpar = msmode
      if (max_plpick.gt.-99) max_plpick_zfpar = max_plpick
      if (maxflt_x.gt.-99) maxflt_patx_zfpar = maxflt_x
      if (maxflt_y.gt.-99) maxflt_paty_zfpar = maxflt_y
      if (maxflt_mag.gt.-99) maxflt_mag_zfpar = maxflt_mag
      if (maxflt_3d.gt.-99) maxflt_3d_zfpar = maxflt_3d
      if (rmax_x.gt.-99) rmax_x_zfpar = rmax_x
      if (rmax_y.gt.-99) rmax_y_zfpar = rmax_y
      if (minmimp_pref.gt.-99) minmimp_pref_zfpar = minmimp_pref
      if (navmode.gt.-99) navmode_zfpar = navmode

      if (whitmin_x.gt.-99.) whitmin_x_zfpar = whitmin_x
      if (whitmin_y.gt.-99.) whitmin_y_zfpar = whitmin_y
      if (whitmin_3d.gt.-99.) whitmin_3d_zfpar = whitmin_3d
      if (whitmin_mag.gt.-99.) whitmin_mag_zfpar = whitmin_mag
      if (f_moliere.gt.-99.) f_moliere_zfpar = f_moliere

      if (cxxrf.gt.-99.)   cxxrf_zfpar   = cxxrf
      if (cyyrf.gt.-99.)   cyyrf_zfpar   = cyyrf
      if (ctxtxrf.gt.-99.) ctxtxrf_zfpar = ctxtxrf
      if (ctytyrf.gt.-99.) ctytyrf_zfpar = ctytyrf
      if (cqqrf.gt.-99.)   cqqrf_zfpar   = cqqrf
      if (qplimit.gt.-99.)  qplimit_zfpar  = qplimit
      if (zmin_ec.gt.-999.) zmin_ec_zfpar  = zmin_ec
      if (zmax_ec.gt.-999.) zmax_ec_zfpar  = zmax_ec
      if (zmin_mag.gt.-999.) zmin_mag_zfpar  = zmin_mag
      if (zmax_mag.gt.-999.) zmax_mag_zfpar  = zmax_mag
      if (segstor.eq.'Y'.or.segstor.eq.'N') 
     +     segstor_zfpar = segstor.eq.'Y'
      if (clmimp_pref.eq.'Y'.or.clmimp_pref.eq.'N') 
     +     clmimp_pref_zfpar = clmimp_pref.eq.'Y'
      if (qmin_x.gt.-999.)  qualmin_x_zfpar = qmin_x
      if (qmin_y.gt.-999.)  qualmin_y_zfpar = qmin_y
      if (nhmin_y.gt.-999)  nhitmin_y_zfpar = nhmin_y
      if (cdgsel.eq.'Y'.or.cdgsel.eq.'N') 
     +     dgsel_zfpar = cdgsel.eq.'Y'


      if (index(chopt,'L').gt.0) then
         print '(15(a12,'' = '',i12/))', ! print integers
     +        'dlevel_zfpar',dlevel_zfpar,
     +        'rlevel_zfpar',rlevel_zfpar,
     +        'smooth_zfpar',smooth_zfpar,
     +        'niter_zfpar',niter_zfpar,
     +        'msmode_zfpar',msmode_zfpar,
     +        'max_plpick',max_plpick_zfpar,
     +        'maxflt_x',maxflt_patx_zfpar,
     +        'maxflt_y',maxflt_paty_zfpar,
     +        'maxflt_mag',maxflt_mag_zfpar,
     +        'maxflt_3d',maxflt_3d_zfpar,
     +        'rmax_x',rmax_x_zfpar,
     +        'rmax_y',rmax_y_zfpar,
     +        'minmimp_pref',minmimp_pref_zfpar,
     +        'nhitmin_y',nhitmin_y_zfpar,
     +        'navmode_y',navmode_zfpar
         print '(17(a12,'' = '',f12.4/))', ! print floats
     +        'whitmin_x',whitmin_x_zfpar,
     +        'whitmin_y',whitmin_y_zfpar,
     +        'whitmin_3d',whitmin_3d_zfpar,
     +        'whitmin_mag',whitmin_mag_zfpar,
     +        'f_moliere',f_moliere_zfpar,
     +        'cxxrf_zfpar',cxxrf_zfpar,
     +        'cyyrf_zfpar',cyyrf_zfpar,
     +        'ctxtxrf_zfpar',ctxtxrf_zfpar,
     +        'ctytyrf_zfpar',ctytyrf_zfpar,
     +        'cqqrf_zfpar',cqqrf_zfpar,
     +        'qplimit_zfpar',qplimit_zfpar,
     +        'zmin_ec_zfpar',zmin_ec_zfpar,
     +        'zmax_ec_zfpar',zmax_ec_zfpar,
     +        'zmin_mag_zfpar',zmin_mag_zfpar,
     +        'zmax_mag_zfpar',zmax_mag_zfpar,
     +        'segstor_zfpar',segstor_zfpar,
     +        'qualmin_x_zfpar',qualmin_x_zfpar,
     +        'qualmin_y_zfpar',qualmin_y_zfpar

         print '(2(a12,'' = '',l12/))',  ! print logicals
     +        'clmimp_pref_zfpar',clmimp_pref_zfpar,
     +        'dgsel_zfpar',dgsel_zfpar
      endif

      end


