*-- Author :    Rainer Mankel   31/05/96

      subroutine tfremcn(it,imcass,fracmc)

      implicit none
#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/RHIT.fi"

      integer it, imcass
      integer nhit,hit,imc,jaux,max_ass,nmxass,jmcass,ind_hit,iihitb
      real fracmc
      parameter (nmxass=40)
      integer mcass(nmxass),nmcass
      parameter (max_ass=40)
      integer i_ass,n_ass,ass(max_ass),count_ass(max_ass),mc_winner,
     +     count_winner

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/RTRA.ff"
#include "auto/RHIT.ff"


*     **** calculate for reconstructed track IT  the
*     **** associated MC particle

      n_ass = 0

*     **** loop over hits used for track
      nhit = 0

      do 10 iihitb=1,999        ! locate hits associated with track
         if (iihitb.eq.1) then
            ind_hit = prtra_hitb(it)
         else
            ind_hit = xrtra_hitb(ind_hit)
         endif
         if (ind_hit.le.0) go to 11
         hit = mrtra_hitb(ind_hit)
         nhit = nhit + 1

*        **** locate MC particles associated with this hit
         call tumclo(hit,nmxass,nmcass,mcass)

*        **** loop over associated MC particles
         do jmcass=1,nmcass
            imc = mcass(jmcass)
            if (imc.lt.1.or.imc.gt.iq(jmtra+2)) then
               print *,' () tfremcn: invalid imc=', imc
               imc = 0
            endif

            do i_ass=1,n_ass    ! check if already registered
               if (ass(i_ass).eq.imc) then
                  count_ass(i_ass) = count_ass(i_ass) + 1
                  go to 20
               endif
            enddo

            if (n_ass.lt.max_ass) then
               n_ass = n_ass + 1 ! register
               ass(n_ass) = imc
               count_ass(n_ass) = 1
            else
               print *,' () tfremcn: overflowing n_ass=', n_ass
            endif
 20         continue
         enddo

 10    continue
       print *,' () tfremcn: loop finished'
 11    continue

*      **** get maximum
       mc_winner = 0
       count_winner = 0

       do i_ass=1,n_ass
          if (count_ass(i_ass).gt.count_winner) then
             mc_winner = ass(i_ass)
             count_winner = count_ass(i_ass)
          endif
       enddo

       imcass = mc_winner
       fracmc = float( count_winner ) / float( nhit )

       end
