// ********************************************************************
//
//  Routine:      rc99Match
//  Author:       T. Oest
//
//  Description:  steering routine for matching
//
//  Modification:
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include "marple/marple.hh"

#include "arte/arte.hh"

extern int matchMARPLEVdsEcal;
extern int matchMARPLEVdsRich;
extern int matchMARPLEEcalRich;
extern int matchVdsRich;
extern int matchVdsEcalRich;
extern int matchTarget;

void rc99SelRTRA();

//
// function
//
int rc99Match()
{
//-----------------------------------------------------------------
//   fit98 matching
//-----------------------------------------------------------------

  rc99SelRTRA();

//-----------------------------------------------------------------
//   marple matching
//-----------------------------------------------------------------
  float PTcut = 0.0;
  if (matchMARPLEVdsEcal){
   matchsvdecal_(& PTcut);
  };
  if (matchMARPLEVdsRich)  matchsvdrich_();
  if (matchMARPLEEcalRich){
   PTcut = 0.0;
   float CherenkovAnglecut = 0.0;
   matchrichecal_(& PTcut, & CherenkovAnglecut);
  };

return 0;
};


