*
*  Author :   A.Spiridonov    16/01/98
*  Changed:   R.Mankel        25/06/99
*
**************************************************************
*                                                            *
      subroutine rcvert
*                                                            *
*     Reconsrtuct K0s       and primary vertices,            *
*     book and fill arte table RVER in the framework         *
*     of ARTE                                                *
*                                                            *
*     The genuine version of T.Lohse vertex package          *
*     and v0fit package was used without tuning              *
*     of parameters and modifications.                       *
*     A few routines : vtrec,vtwir,vtrini,vtpsto,            *
*     was added to use T.Lohse vertex package                *
*     in arte environment                                    *
*                                                            *
*     The user must make sure that the arte table RTRA       *
*     (reconstucted tracks) was booked and filled            *
*     ( f.e. by ranger ) before call of this routine         *
*                                                            *
**************************************************************
      implicit none
      integer flag
**    real time_0,time_v0,time_prim,job_time
*=============================================================
*
**    call timex(time_0)
*
*                                K0s vertices
*
      call v0K0s
*
*                                No J/psi vertices (part of analysis)
*
***      call v0psi
*
**    call timex(time_v0)
**    job_time=time_v0-time_0
**    print *,' CPU time for v0 vertices ', job_time,' seconds'
*
*                                primary vertices
*
      call vtrec(flag)
      call vtpsto(flag)
*
**    call timex(time_prim)
**    job_time=time_prim-time_v0
**    print *,' CPU time for primary vertices ', job_time,' seconds'
*
  999 return
      end
