#ifndef _GCAL_HH_
#define _GCAL_HH_
struct GCAL {
   int ncl;
   int sec;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float xmad;
   float ymad;
   float zmad;
   float eff;
   float ms;
   int cmp;
   ArtePointer<GESL> gesl;
   ArtePointer<GMAT> gmat;
   char gvol[4];
   int fcl;
   int mim1;
   int miml;
   int dig1;
   int digl;
   int hit1;
   int hitl;
};
#include "auto/GESL.hh"
#include "auto/GSGC.hh"
#include "auto/GMAT.hh"
#include "auto/GMGC.hh"
#include "auto/GCAL.icc"
#endif
