#ifndef _GMAT_HH_
#define _GMAT_HH_
struct GMAT_GEDE;
struct GMAT_GCAL;
struct GMAT_GWAL;
struct GMAT_NEDE;
struct GMAT_NCAL;
struct GMAT_NWAL;
struct GMAT {
   char name[12];
   float a;
   float z;
   float dens;
   float radl;
   float absl;
   int nmix;
   int flag;
   int gmix;
   float loss;
   ArteRelationPointer<GMAT_GEDE> gede;
   ArteRelationPointer<GMAT_GCAL> gcal;
   ArteRelationPointer<GMAT_GWAL> gwal;
   ArteRelationPointer<GMAT_NEDE> nede;
   ArteRelationPointer<GMAT_NCAL> ncal;
   ArteRelationPointer<GMAT_NWAL> nwal;
};
#include "auto/GEDE.hh"
#include "auto/GMGD.hh"
#include "auto/GCAL.hh"
#include "auto/GMGC.hh"
#include "auto/GWAL.hh"
#include "auto/GMGW.hh"
#include "auto/NEDE.hh"
#include "auto/GMND.hh"
#include "auto/NCAL.hh"
#include "auto/GMNC.hh"
#include "auto/NWAL.hh"
#include "auto/GMNW.hh"
#include "auto/GMAT.icc"
#endif
