#ifndef _MTRA_HH_
#define _MTRA_HH_
struct MTRA_RTRA;
struct MTRA_ETRA;
struct MTRA_EVER;
struct MTRA_MIMP;
struct MTRA_MCAL;
struct MTRA_RSEG;
struct MTRA_RCCL;
struct MTRA {
   float px;
   float py;
   float pz;
   float ml;
   int flag;
   ArtePointer<TOPP> topp;
   int orig;
   ArteRelationPointer<MTRA_RTRA> rtra;
   float mass;
   float leng;
   ArtePointer<MVER> bver;
   ArtePointer<MTRA> btra;
   ArteRelationPointer<MTRA_ETRA> etra;
   ArteRelationPointer<MTRA_EVER> ever;
   ArteRelationPointer<MTRA_MIMP> mimp;
   ArteRelationPointer<MTRA_MCAL> mcal;
   ArteRelationPointer<MTRA_RSEG> rseg;
   ArteRelationPointer<MTRA_RCCL> rccl;
   ArtePointer<MTCP> mtcp;
};
#include "auto/TOPP.hh"
#include "auto/MTTO.hh"
#include "auto/RTRA.hh"
#include "auto/RTMT.hh"
#include "auto/MVER.hh"
#include "auto/MVMT.hh"
#include "auto/MTMT.hh"
#include "auto/MTMV.hh"
#include "auto/MIMP.hh"
#include "auto/MTMI.hh"
#include "auto/MCAL.hh"
#include "auto/MTMC.hh"
#include "auto/RSEG.hh"
#include "auto/RSMT.hh"
#include "auto/RCCL.hh"
#include "auto/MTRC.hh"
#include "auto/MTCP.hh"
#include "auto/MTMP.hh"
#include "auto/MTRA.icc"
#endif
