#ifndef _NCAL_HH_
#define _NCAL_HH_
struct NCAL {
   int ncl;
   int sec;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float xmad;
   float ymad;
   float zmad;
   float eff;
   float ms;
   int cmp;
   ArtePointer<NESL> nesl;
   ArtePointer<GMAT> gmat;
   char gvol[4];
};
#include "auto/NESL.hh"
#include "auto/NSNC.hh"
#include "auto/GMAT.hh"
#include "auto/GMNC.hh"
#include "auto/NCAL.icc"
#endif
