#ifndef _RCCL_HH_
#define _RCCL_HH_
struct RCCL_RTRA;
struct RCCL_HITC;
struct RCCL_MTRA;
struct RCCL_RSEG;
struct RCCL {
   float z;
   float x;
   float y;
   float tx;
   float ty;
   float esum;
   float cve[15];
   float wid;
   float asym;
   int flag;
   float lemp;
   float lmip;
   float lhad;
   float xcog;
   float ycog;
   float vcog[3];
   ArteRelationPointer<RCCL_RTRA> rtra;
   ArteRelationPointer<RCCL_HITC> hitc;
   ArteRelationPointer<RCCL_MTRA> mtra;
   ArteRelationPointer<RCCL_RSEG> rseg;
};
#include "auto/RTRA.hh"
#include "auto/RTRC.hh"
#include "auto/HITC.hh"
#include "auto/HCRC.hh"
#include "auto/MTRA.hh"
#include "auto/MTRC.hh"
#include "auto/RSEG.hh"
#include "auto/RSRC.hh"
#include "auto/RCCL.icc"
#endif
