*-- Author :    Vik   11/11/98

      SUBROUTINE DGTRDS(IPL)

**********************************************************************
*
* Description: TRD DIGI
*
* Called from: DGEVNT
*
* 
*
* Arguments: none
*
*********************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcvolu.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"
#include "auto/MIMP.fi"
#include "auto/DIGB.fi"
#include "auto/HITB.fi"

      REAL X0, Y0, X_LEFT, Y_LEFT, ANGL, DE(12,16,78),XWIR, ZWIR,
     +     X_NEW_LEFT, Y_NEW_LEFT, X_NEW, Y_NEW, D_STRAW, E_THR, PIRAD
      INTEGER ROW, IMP, ICOD, N_BLOK, N_STRAW, N_LAYER, IPL,
     +        I_STRAW, HELP_MIMP, MXHELP, NN, NN1, N_ISEC, IMP_NEW,
     +        FLAG_DIGI, FLAG_HITB, STRAW, IMP_1, IMP_2
      INTEGER I,II
C
      INTEGER TRDMIMP, TRD_MIMP_BL, NMIM, IFMIMP, MXHIT, IH
      REAL TRD_MIMP_X1, TRD_MIMP_Y1, TRD_MIMP_Z1,
     +                  TRD_MIMP_X16, TRD_MIMP_Y16, TRD_MIMP_Z16
      CHARACTER*600 TRDMIMPvalues40
C
      COMMON /TRD_MIMP/ TRD_MIMP_X1, TRD_MIMP_Y1, TRD_MIMP_Z1,
     +                  TRD_MIMP_X16, TRD_MIMP_Y16, TRD_MIMP_Z16,
     +                  TRD_MIMP_BL
C
      PARAMETER (MXHELP = 10000)
      PARAMETER (MXHIT  = 10000)
C...
      DIMENSION HELP_MIMP(5,MXHELP), XWIR(MXHELP), ZWIR(MXHELP)
C...
      DATA N_ISEC /6/, E_THR/5.0/, PIRAD/3.14159/
C
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/DIGB.ff"
#include "auto/HITB.ff"
C
C TRD DIGI Analysis.
C
      NMIM = 0
      IFMIMP  = IGEDE_MIM1(IPL)
      IF(IFMIMP.NE.0) NMIM  = IGEDE_MIML(IPL) - IFMIMP + 1
      IF(NMIM.LE.0) GO TO 998
      IF(NMIM.GT.MXHIT) THEN
         C78 = 'DGTRDS: NMIM > MAXHIT for IPL '
         CALL CH78AI(NMIM)
         CALL CH78AC(' for ')
         CALL CH78AI(IPL)
         CALL ME78WC(18282800)
         NMIM = MXHIT
      ENDIF
C
      IMP_NEW = 0
      IMP_1 = 0
      IMP_2 = 0
      ROW     = IPL
      D_STRAW = Q(QGEDE_PIT(ROW))
C
      CALL VZERO(DE,14976)
c      CALL VZERO(HELP_MIMP,50000)

      do i=1,10000
      do ii=1,5
      HELP_MIMP(ii,i) = 0
      enddo
      enddo
     
      CALL VZERO(XWIR,MXHELP)
      CALL VZERO(ZWIR,MXHELP)

        DO IH = 1, NMIM
C...
           IMP = IH+IFMIMP-1
           IF(IMIMP_GEDE(IMP).EQ.ROW.AND.
     +        ABS(FMIMP_TX(IMP)).GT.0.0) THEN

              X0     = FMIMP_X(IMP)
              Y0     = FMIMP_Y(IMP)
              X_LEFT = FGEDE_XMIN(ROW)
              Y_LEFT = FGEDE_YMIN(ROW)
C...
              IF(IGEDE_SEC(ROW).LE.N_ISEC) THEN
                 ANGL = -1.*PIRAD/3.
              ELSE
                 ANGL = PIRAD/3.
              END IF
C
C NUMBER OF STRAW CALC.
C

              X_NEW_LEFT =   X_LEFT*COS(ANGL) + Y_LEFT*SIN(ANGL)
              Y_NEW_LEFT = - X_LEFT*SIN(ANGL) + Y_LEFT*COS(ANGL)

              ANGL = - ANGL

              X_NEW = (X0 - X_NEW_LEFT)*COS(ANGL) + 
     +             (Y0 - Y_NEW_LEFT)*SIN(ANGL)
              Y_NEW = -1.*(X0 - X_NEW_LEFT)*SIN(ANGL) + 
     +             (Y0 - Y_NEW_LEFT)*COS(ANGL)

              N_STRAW = INT(X_NEW/D_STRAW) + 1
              IF(N_STRAW.GE.1 .AND. N_STRAW.LE.78) THEN 
                 N_BLOK  = IGEDE_SEC(ROW)
                 N_LAYER = IGEDE_LAY(ROW)

                 IMP_NEW = IMP_NEW + 1

                 HELP_MIMP(1,IMP_NEW) = N_BLOK
                 HELP_MIMP(2,IMP_NEW) = N_LAYER
                 HELP_MIMP(3,IMP_NEW) = N_STRAW
                 HELP_MIMP(4,IMP_NEW) = IMP
                 HELP_MIMP(5,IMP_NEW) = IMIMP_GEDE(IMP)
C...
                 XWIR(IMP_NEW)  = FGEDE_XMIN(ROW) + (N_STRAW-1)*0.61 
     +                                                       + 0.305
                 ZWIR(IMP_NEW)  = FGEDE_ZFW(1,ROW)
C...
                 IF(ABS(FMIMP_TX(IMP)).GT.0.0) 
     &                DE(N_BLOK,N_LAYER,N_STRAW)=
     &                DE(N_BLOK,N_LAYER,N_STRAW) + FMIMP_TX(IMP)
              ENDIF
C...
             END IF
C...
      END DO

      DO STRAW = 1, 78
C
         FLAG_DIGI = 0
         FLAG_HITB = 0
C
         DO IMP = 1, IMP_NEW
C...
            IF(HELP_MIMP(4,IMP).NE.0) THEN
C...

               N_STRAW = HELP_MIMP(3,IMP)
C...
               IF(STRAW.EQ.N_STRAW) THEN
C...
               N_BLOK  = HELP_MIMP(1,IMP)
               N_LAYER = HELP_MIMP(2,IMP)
C..
               IF(DE(N_BLOK,N_LAYER,N_STRAW).GT.E_THR) THEN
C...
                  IF(FLAG_DIGI.EQ.0) THEN
C...
                     FLAG_DIGI = 1
C...
                    IMP_1 = IMP_1 + 1
C...
                     CALL MMBOOK(JDIGB,1)
                     NN1 = NDIGB()
C...
                     IQ(IQDIGB_ID_L()) = N_STRAW*10000 + 
     +                                         HELP_MIMP(5,IMP)
                     Q (QDIGB_Q_L())   = DE(N_BLOK,N_LAYER,N_STRAW)
C...
                     IF(IMP_1.EQ.1) IQ(IQGEDE_DIG1(IPL)) = NN1
C...
               END IF
C...
               CALL MMBREL(JMIDI,HELP_MIMP(4,IMP),NN1)
C...
                  IF(FLAG_HITB.EQ.0) THEN
C
                    FLAG_HITB = 1
C
                    CALL MMBOOK(JHITB,1)
                    NN = NHITB()  
C...
                    IMP_2 = IMP_2 + 1
C...
                    IQ(IQHITB_GEDE_L()) = HELP_MIMP(5,IMP)
                    Q (QHITB_X_L())     = XWIR(IMP)
                    Q (QHITB_Z_L())     = ZWIR(IMP)
                    Q (QHITB_Q_L())     = DE(N_BLOK,N_LAYER,N_STRAW)
*                    Q (QHITB_R_L())     = FGEDE_ACC(HELP_MIMP(5,IMP))
C...
                    IF(IMP_2.EQ.1) IQ(IQGEDE_HIT1(IPL)) = NN
C...
                  CALL MMBREL(JHIDI,NN,NN1)                    
C...
                  END IF
C...
                  CALL MMBREL(JMIHI,HELP_MIMP(4,IMP),NN)

               END IF
C...
             END IF
C...
            END IF
C...
           END DO
         END DO
C
      IQ(IQGEDE_DIGL(IPL)) = NN1
      IQ(IQGEDE_HITL(IPL)) = NN

 900  RETURN
C
 998  IQ(IQGEDE_DIG1(IPL)) = 0
      IQ(IQGEDE_HIT1(IPL)) = 0
      IQ(IQGEDE_DIGL(IPL)) = -1
      IQ(IQGEDE_HITL(IPL)) = -1
      RETURN
      END

*********************************************************************
* End of DGTRDS
************************************************************************
