
      SUBROUTINE CRGCAL(NCL,IVOL,PAR)

************************************************************************
*
* CRGCAL
* written by Siegmund Nowak
*
* This routine books and fills the detector ZEBRA bank
*
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* var1        in           this variable will only be read
*
*
************************************************************************

      IMPLICIT NONE

      INTEGER NN,NCL,IVOL,JVOS,NUMED,NMAT,MATNUM,NMM,LENOCC,JPL,I
      REAL PAR(8)
      CHARACTER MATNAM*20,CNAME*4

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      CALL MMBOOK(JNCAL,1)
      NN = NNCAL()
      IQ(IQNCAL_CMP_L()) = INESL_CMP(CURRSL)
c      IQ(JNCAL+2 + (NN-1)*NCNCAL()+JNCAL_NESL) = CURRSL
      CALL MMBREL(JNSNC,CURRSL,NN)

      IF(INESL_FPL(CURRSL).EQ.0) IQ(IQNESL_FPL(CURRSL)) = NN   
      IQ(IQNESL_NPL(CURRSL)) = IQ(IQNESL_NPL(CURRSL)) + 1
      IQ(IQNCAL_NCL_L()) = NCL
      IQ(IQNCAL_SEC_L()) = NNCAL()

      CALL UCOPY(PAR,Q(QNCAL_XMIN_L()),6)
      
      IQ(HQNCAL_GVOL_L()) = IQ(JVOLUM+IVOL)
      CALL UHTOC(Q(JVOLUM+IVOL),4,CNAME,4) 
      JVOS = LQ(JVOLUM-IVOL)
      NUMED = Q(JVOS+4)
      NMAT = Q(LQ(JTMED-NUMED)+6)
      CALL UHTOC(Q(LQ(JMATE-NMAT)+1),4,MATNAM,20)
      NMM = MATNUM(MATNAM(1:LENOCC(MATNAM)))
c      IQ(JNCAL+2 + (NN-1)*NCNCAL()+JNCAL_GMAT) 
c     +                        = MATNUM(MATNAM(1:LENOCC(MATNAM)))  
      CALL MMBREL(JGMNC,NMM,NN)
      RETURN
 101  FORMAT(1X,'CAL ',I4,6(1X,F7.2),'  ',A4)
      END



