#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

extern "C" {
  char* ku_getc();
  int  matnum_(char*,int); 

  void kawire() {
    char buffer[4], tag[13], mat[12];
    strcpy(buffer, ku_getc());
    if(!strncmp(buffer,"MAT",2)) {
      memset(mat,' ',12);
      strcpy(tag, ku_getc());
      char * ptr =  strtok(tag,"/");
      if(!strcmp(ptr,"ALUMINIUM")      || !strcmp(ptr,"AL")) 
                                           strcpy(mat,"ALUMINIUM");
      else if(!strcmp(ptr,"CARBON")    || !strcmp(ptr,"C"))  
                                           strcpy(mat,"CARBON");
      else if(!strcmp(ptr,"COPPER")    || !strcmp(ptr,"CU")) 
                                           strcpy(mat,"COPPER");
      else if(!strncmp(ptr,"TITAN",5)  || !strcmp(ptr,"TI"))     
                                           strcpy(mat,"TITANIUM");
      else if(!strcmp(ptr,"TUNGSTEN")  || !strcmp(ptr,"W"))
                                           strcpy(mat,"TUNGSTEN");
      else if(!strcmp(ptr,"BERYLLIUM") || !strcmp(ptr,"BE"))
                                           strcpy(mat,"BERYLLIUM");
      else {
          arteMsg << "kawire: target material " << ptr << " not foreseen";
          arteMsg.error();
      }
      int imat = matnum_(mat,strlen(mat)); 
      ArteTableIterator<GTAR> gt;
      for(; gt.valid(); gt.next()){
	if(tag[0] != '/') { 
           if(gt->cmp != imat) gt->eff = 0.;
        }
        else {
           if(gt->cmp == imat) gt->eff = 0.;
        }
      }	   
    }            
    else if (!strncmp("ALL",&buffer[1],3)) {
        float  eff = atof(ku_getc());
        ArteTableIterator<GTAR> gt;
        for(; gt.valid(); gt.next()){ 
	  if(!strncmp(buffer,gt->name,1)) gt->eff = eff;
        }
    }
    else {   
        ArteTableIterator<GTAR> gt;
        int found = 0; 
        for(; gt.valid(); gt.next()){ 
      	   if(!strncmp(buffer,gt->name,2)) {
              found = 1;  break;
           }  
        }
	if(!found) {
          arteMsg << "kawire: check command " << buffer ;
          arteMsg.error();
        }
        else gt->eff = atof(ku_getc()); 
    }
  }
	 
}




