*-- Author :    Thomas Lohse   March 8, 1999

      SUBROUTINE KAJPSI

************************************************************************
*
* Description: MODE/PSI command; defines mode and parameters for 
*                                simulation of direct J/Psi production 
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "pyth/PYSUBS.fi"
#include "arte/luopts.fi"

      INTEGER L, mes_id_1
      CHARACTER*12 CH

      save mes_id_1

      call KUGETC(CH, L)
      if (CH(1:2).eq.'PT') then
        modePsi = 1
      elseif (CH(1:2).eq.'RE') then
        modePsi = 2
      else
        call MEERRC(mes_id_1, 'MODE/PSI: generator mode unknown')
        modePsi = 2
      endif
      if (modePsi.eq.1) then
        call KUGETR(pt0psi)
        CKIN(5) = pt0psi
      else
        pt0psi = CKIN(5)
      endif


 90   END

************************************************************************
* End of KAJPSI
************************************************************************
