*CMZ :          05/09/96  20.01.49  by  Fedor Ratnikov
*CMZ :  1.00/01 26/02/95  19.49.22  by  Fedor Ratnikov
*CMZ :  1.00/00 22/12/94  19.31.31  by  Dominik Ressing
*-- Author :    Dominik Ressing   10/12/94
************************************************************************
*
* L1GETRS
* written by Dominik Ressing, 10/12/94 14.40.10
*
* This routines action:
* Find tracks for points
*----------------------------------------------------------------------*
* iHiPos      in       Hit pointer for the found hits
* N           update   Dimension of itrs(*) on input; # of found tracks on output
* itrs(N)     out      first completly covered track
*
************************************************************************
c
      SUBROUTINE L1GETR0(iHiPos,N,itrs)
c
      IMPLICIT NONE
#include "arte/Arte.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1clink.fi"
#include "l1si/rcfdef.fi"
c
      INTEGER iHiPos,itrs(*),N
      REAL    z,P,x,y,Pa
c
      INTEGER ila,imask,i,k,nfou,jAux,
     &        iMax,itr
c
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
c
      Nfou = 0
c
      iMax = N_U(JL1_MESS)
c
      IF ( iHiPos.ge.1 .and. iHiPos.le.iMax ) THEN
         jAux = I_1(iHiPos,JL1_ME_MTRA)
      ELSE
         jAux = 0
      END IF
      DO WHILE ( jAux.gt.0 )    ! relation pointer valid ??
         itr  = K_1(jAux,JL1_ME_MTRA)
         jAux = N_1(jAux,JL1_ME_MTRA)
c
         DO k=1,Nfou
            IF ( itrs(k).eq.itr ) THEN
               GO TO 333
            END IF
         END DO
         IF ( Nfou.eq.N ) GO TO 444
         Nfou = Nfou + 1
         itrs(  Nfou) = itr
c
 333     CONTINUE
      END DO
c
      GO TO 555
c
 444  CONTINUE
      WRITE (L1LUNprn,*) 'L1GETR0 ==> to many tracks',Nfou,N
c
 555  CONTINUE
c
      N = Nfou
c
      RETURN
c
      END


