*CMZ :          06/09/96  21.08.33  by  Fedor Ratnikov
*CMZ :  1.04/01 26/01/95  20.29.06  by  Dominik Ressing
*-- Author :    Hartwig Albrecht   11/11/94

C  Establish the relation between two specific rows I1 and I2 for the
C  relation denoted by IX and L. The tables which the two rows belong to
C  and the distinction between one-to-many and many-to-many are known from
C  the previous call to UTBREL.

      SUBROUTINE UTEREL (IX, L, I1, I2)

      IMPLICIT NONE

      INTEGER IX, L(*), I1, I2

#include "arte/Arte.fi"
#include "l1si/rcfdef.fi"
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"


c
c     --- check for valid input parameters: row.eq.0 will spoil the bank-chaining DR.
c
      IF ( I1.le.0 .or. I2.le.0 ) THEN
         WRITE(6,*) 'UTEREL==> invalid row number I1,I2:',I1,I2
         RETURN
      END IF


      IF (IQ(L(1)+5) .EQ. 1)  THEN

C         one-to-many

         IF (IQ(L_A(IQ(L(1)+4),I2,LQ(L(1)-2))) .EQ. 0.OR.
     &        IQ(L(1)+4) .EQ.0)                         THEN
          IF (IQ(L(1)+4) .GT. 0)
     +      IQ(L_A(IQ(L(1)+4),I2,LQ(L(1)-2))) = I1
          IF (N_F (L(1)) .LE. 0)  CALL UTETAB (IX, L, 500)
          IQ(L_A(1,N_U(L(1))+1,L(1))) = I2
          IQ(L_A(2,N_U(L(1))+1,L(1))) = I_V(IQ(L(1)+3),I1,LQ(L(1)-1))
          IQ(L_A(IQ(L(1)+3),I1,LQ(L(1)-1))) = IQ(L(1)+2) * 2
          IQ(L(1)+2) = IQ(L(1)+2) + 1
        END IF

      ELSE

C          many-to-many

        IF (N_F (L(1)) .LE. 1)  CALL UTETAB (IX, L, 500)
        IQ(L_A(1,N_U(L(1))+1,L(1))) = I2
        IQ(L_A(2,N_U(L(1))+1,L(1))) = I_V(IQ(L(1)+3),I1,LQ(L(1)-1))
        IQ(L_A(IQ(L(1)+3),I1,LQ(L(1)-1))) = IQ(L(1)+2) * 2
        IQ(L_A(3,N_U(L(1))+1,L(1))) = I1
        IQ(L_A(4,N_U(L(1))+1,L(1))) = I_V(IQ(L(1)+4),I2,LQ(L(1)-2))
        IQ(L_A(IQ(L(1)+4),I2,LQ(L(1)-2))) = IQ(L(1)+2) * 2
        IQ(L(1)+2) = IQ(L(1)+2) + 2
      END IF

      END
