#include <arte/arte.hh>
#include <gean/ZGESL.h>
#include "marple/marple.hh"

bool maMagnetON()
{
  static int initialized = 0;
  static ArtePointer<GESL> gesl;
  if( ! initialized )
    {  // search for FLD GESL  
      initialized = 1;
      for( ArteTable<GESL>::iterator igesl = ArteTable<GESL>::begin();
	   igesl != ArteTable<GESL>::end(); ++igesl )
	{
	  if( (*igesl)->cmp == LGESL_FLD ) 
	    {
	      gesl = (*igesl);
	    }
	}
    }
  MARPLE_MagnetON = gesl->mfl;
  /*
  if( gesl->mfl )
    cout << " MARPLE supposes that magnet is ON\n";
  else
    cout << " MARPLE supposes that magnet is OFF\n";
    */
  return MARPLE_MagnetON;
}
