      SUBROUTINE MAMAKENT( INTUP, TYPE)
      IMPLICIT NONE

#include "marple/matchnt.fi"
#include "marple/deltas.fi"
      INTEGER INTUP             !  number of ntuple to create
      INTEGER TYPE              !  type of ntuple
                                !    = 1 means matchnt of general type
                                !    = 2       matchnt for RcSegClusBuilder
                                !    = 3       deltas ntuple
                                !    = 4       pulses ntuple

      IF( type .eq. 1 ) then
         CALL HBNT(  iNtup,'matchNT',' ')
         CALL HBNAME(iNtup,'N_evnt',Nevt,'Nevt:I, Nleft:I, Nright:I,
     +        Nmatch:I, Nbad:I, Nlost:I,
     +        Nreal:I, Rbad:R, Rlost:R, fromJpsi:I')
      ELSEIF( type .eq. 2 ) then
         CALL HBNT(  iNtup,'matchSC',' ')
         CALL HBNAME(iNtup,'N_evnt',Nevt,'Nevt:I, Nleft:I, Nright:I,
     +        Nmatch:I, Nbad:I, Nlost:I, Nreal:I,
     +        Rbad:R, Rlost:R, fromJpsi:I, RbadB:R,
     +        Rlmtra:R, Rlelec:R, Rlelecj:R, 
     +        RlmtraB:R, RlelecB:R, RlelecjB:R')
      ELSEIF( type .eq. 3 ) then
         CALL HBNT(  iNtup,'deltas',' ')
         CALL HBNAME(iNtup,'delta',flag,'flag:I, deltaX:R, deltaY:R,
     +        deltaTX:R, deltaTY:R, deltaPE:R, chi2:R')
         CALL HBNAME(iNtup,'ENERGY',leftp,'leftp:R, rightp:r')
         CALL HBNAME(iNtup,'MC',ipart1,
     +        'ipart1:I, ipart2:I, imoth1:I, imoth2:I')
      ELSEIF( type .eq. 4 ) then
         CALL HBNT(  iNtup,'pulses',' ')
         CALL HBNAME(iNtup,'flag',flag,'flag:I')
         CALL HBNAME(iNtup,'chi2',chi2,'chi2:R')
         CALL HBNAME(iNtup,'energy',leftp,'leftp:R, rightp:r')
         CALL HBNAME(iNtup,'puls',lpulsX,
     +        'lpulsX:R, lpulsY:R, lpulsTX:R, lpulsTY:R, lpulsPE:R,
     +        rpulsX:R, rpulsY:R, rpulsTX:R, rpulsTY:R, rpulsPE:R')
      endif


      
 999  RETURN
      END
