
* routine to add the tubeor pad chamber wire to the HITB table
* made by Boris Fominykh 12.03.1999

      SUBROUTINE MUADDT(IV,IWIR)
C+    ==========================

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/GEO.fi"

      INTEGER IV,IWIR,FLAG
      REAL DISWIR,XFWIR,XD1,XW,ZW

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"
C     -------------------
* input control
      IF(IV.LE.0.OR.IV.GT.IQ(JGEDE+2)) RETURN
      IF(IWIR.LT.0.OR.IWIR.GT.15) RETURN
* fix the first entry per volume
      FLAG=0
      IF(IGEDE_HIT1(IV).GT.IGEDE_HITL(IV)) FLAG=1
* book the new entry
      CALL MMBOOK(JHITB,1)
* check that HITB exists
      IF(JHITB.LE.0) RETURN

      IF(FLAG.EQ.1) IQ(IQGEDE_HIT1(IV)) = IQ(JHITB+2)
* chamber parameters
      DISWIR =  FGEDE_PIT(IV)   ! distance between wires
      XFWIR  =  FGEDE_XFW(1,IV) ! X-position of first wire
      XD1 =  FGEDE_XMIN(IV)     ! x of left corner

      XW = XD1+XFWIR+DISWIR*REAL(IWIR)
      ZW = FGEDE_ZFW(1,IV)      ! z-position of wire

*      print*,'muaddt: added the wire X,Z,IV ',XW,ZW,IV

      Q(QHITB_X_L())   =  XW
      Q(QHITB_Y_L())   =  0.
      Q(QHITB_Z_L())   =  ZW
      Q(QHITB_Q_L())   =  0.
      IQ(IQHITB_GEDE_L())= IV
      IQ(IQGEDE_HITL(IV)) = IQ(JHITB+2)

      RETURN
      END
