*
* B.Fominykh  20.08.97
*
* write the impact point to calorimeter into table RPNT
      SUBROUTINE MUREXCAL(ISG)
*     ========================
* input: ISG - #segment
*
      IMPLICIT NONE
*
#include "murec/MUCKALF.fi"
#include "murec/MUCPAR.fi"
#include "arte/Arte.fi"
#include "auto/RPNT.fi"
      INTEGER ISG,IPN,JPN,I,J,IOUT
      REAL DD,SIGE,CHI
      DOUBLE PRECISION PARS(5),COVS(4,4),WWD
*
      integer matrix_pack(5,5) ! (copied from R. M.)
      data matrix_pack
     +     / 1,  2,  4,  7, 11,
     +       2,  3,  5,  8, 12,
     +       4,  5,  6,  9, 13,
     +       7,  8,  9, 10, 14,
     +      11, 12, 13, 14, 15 /
      save matrix_pack
*
C----+===1=========2=========3=========4=========5=========6=========7==********
* book RPNT
      IF(JRPNT.LE.0) THEN
        CALL MMBOOK(JRPNT,0)
        IF(JRPNT.LE.0) GOTO 999
      ENDIF
      IF(IQ(JRPNT+1).LE.0) GOTO 999
* save parameters and covariance
      DO I=1,5
       PARS(I)=PARAM(I)
      ENDDO
      DO I=1,4
       DO J=1,4
        COVS(I,J)=COV(I,J)
       ENDDO
      ENDDO
* transport the parameters and covariance
      ZMEAS=ZCALEX
      CALL MURKALF(1,IOUT,DD,SIGE,CHI)
* add one raw 
      CALL MMBOOK(JRPNT,1)
* fill the raw
      IPN=IQ(JRPNT+2)
      JPN=JRPNT+IQ(JRPNT+1)*(IPN-1)+2
* parameters
      Q(JPN+JRPNT_ZF) = PARAM(1)

      IF(DABS(PARAM(2)).GT.1.E-10.AND.
     +   DABS(PARAM(2)).LT.1.E+10)
     +   Q(JPN+JRPNT_XF) = PARAM(2)
      IF(DABS(PARAM(2)).LE.1.E-10)
     +   Q(JPN+JRPNT_XF) = 1.E-10
      IF(DABS(PARAM(2)).GE.1.E+10)
     +   Q(JPN+JRPNT_XF) = 1.E+10

      IF(DABS(PARAM(3)).GT.1.E-10.AND.
     +   DABS(PARAM(3)).LT.1.E+10)
     +   Q(JPN+JRPNT_YF) = PARAM(3)
      IF(DABS(PARAM(3)).LE.1.E-10)
     +   Q(JPN+JRPNT_YF) = 1.E-10
      IF(DABS(PARAM(3)).GE.1.E+10)
     +   Q(JPN+JRPNT_YF) = 1.E+10

      IF(DABS(PARAM(4)).GT.1.E-10.AND.
     +   DABS(PARAM(4)).LT.1.E+10)
     +   Q(JPN+JRPNT_TXF) = PARAM(4)
      IF(DABS(PARAM(4)).LE.1.E-10)
     +   Q(JPN+JRPNT_TXF) = 1.E-10
      IF(DABS(PARAM(4)).GE.1.E+10)
     +   Q(JPN+JRPNT_TXF) = 1.E+10

      IF(DABS(PARAM(5)).GT.1.E-10.AND.
     +   DABS(PARAM(5)).LT.1.E+10)
     +   Q(JPN+JRPNT_TYF) = PARAM(5)
      IF(DABS(PARAM(5)).LE.1.E-10)
     +   Q(JPN+JRPNT_TYF) = 1.E-10
      IF(DABS(PARAM(5)).GE.1.E+10)
     +   Q(JPN+JRPNT_TYF) = 1.E+10

      Q(JPN+JRPNT_PF) = 0.

* pack covariance
        DO I=1,5
         DO J=I,5
          IF(I.LT.5.AND.J.LT.5) THEN
           WWD=0.5*(COV(I,J)+COV(J,I))
           IF(DABS(WWD).GT.1.E-10.AND.DABS(WWD).LT.1.E+10) THEN
            Q(JPN+JRPNT_CVF+matrix_pack(I,J)-1)=WWD
           ELSE
            IF(DABS(WWD).LE.1.E-10)
     +      Q(JPN+JRPNT_CVF+matrix_pack(I,J)-1)=1.E-10
            IF(DABS(WWD).GE.1.E+10)
     +      Q(JPN+JRPNT_CVF+matrix_pack(I,J)-1)=1.E+10
           ENDIF
          ELSE
           Q(JPN+JRPNT_CVF+matrix_pack(I,J)-1)=0.
          ENDIF
         ENDDO
        ENDDO
*
* relation "track segment" - "point on track"
        CALL MMBREL(JRSRP,ISG,IPN)   ! #segment - #point
  20  CONTINUE
*
* restore parameters and covariance
      DO I=1,5
       PARAM(I)=PARS(I)
      ENDDO
      DO I=1,4
       DO J=1,4
        COV(I,J)=COVS(I,J)
       ENDDO
      ENDDO
*
 999  CONTINUE
      RETURN
      END









