*
* B.Fominykh  10.05.99
* the program of the MUREC-B package
* writes the muon segments and relations into RSEG
*
      SUBROUTINE MURTABB
*     ==================
      IMPLICIT NONE
*
#include "murec/MUCBTAB.fi"
#include "murec/MUCKALF.fi"
#include "arte/Arte.fi"
#include "arte/RSEG_cmp.fi"
#include "auto/RSEG.fi"
#include "auto/RHIT.fi"

      INTEGER I,J,IJ,IT,JT,ISG,JSG,ICC,IC,JC,NHT,IH,JH,NH,IHB
      INTEGER IHT(50),MCT,ISD,JSD,ISGP,IRH,JRH
      REAL XF,YF,ZF,TXF,TYF,Z

      integer matrix_pack(5,5) ! (copied from R. M.)
      data matrix_pack
     +     / 1,  2,  4,  7, 11,
     +       2,  3,  5,  8, 12,
     +       4,  5,  6,  9, 13,
     +       7,  8,  9, 10, 14,
     +      11, 12, 13, 14, 15 /
      save matrix_pack

#include "arte/Arte.ff"
#include "auto/RSEG.ff"
#include "auto/RHIT.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********

* check-point
      IF(JTMP7.LE.0) GOTO 999
      IF(IQ(JTMP7+1).LE.0) GOTO 999
      IF(IQ(JTMP7+2).LE.0) GOTO 999

* loops over selected branchs
      DO 100 IT=1,IQ(JTMP7+2)
        JT=JTMP7+IQ(JTMP7+1)*(IT-1)+2
        IF(IQ(JT+1).NE.2) GOTO 100
* list of hits
        NHT=0
        DO 10 ICC=1,IQ(JT+8)
          IC=IQ(JT+LCMUTR+ICC)
          JC=JTMP8+IQ(JTMP8+1)*(IC-1)+2
          DO IH=IQ(JC+15),IQ(JC+16)
            JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
            IF(IQ(JH+13).EQ.IC) THEN
              NHT=NHT+1
              IHT(NHT)=IH
            ENDIF
          ENDDO
  10    CONTINUE
        IF(NHT.LT.3) GOTO 100
* inversion
        DO I=1,NHT/2
          J=IHT(I)
          IHT(I)=IHT(NHT-I+1)
          IHT(NHT-I+1)=J
        ENDDO

* seed parameters 
        ISD=IQ(JT+4)
        IF(ISD.LE.0.OR.ISD.GT.IQ(JTMP6+2)) GOTO 100
        JSD=JTMP6+IQ(JTMP6+1)*(ISD-1)+2

* RSEG check-point
      IF(JRSEG.LE.0) THEN
        CALL MMBOOK(JRSEG,0)
        IF(JRSEG.LE.0) GOTO 999
      ENDIF
      IF(IQ(JRSEG+1).LE.0) GOTO 999
* add the new segment into RSEG
        CALL MMBOOK(JRSEG,1)
* #segment
        ISG=IQ(JRSEG+2)
        JSG=JRSEG+IQ(JRSEG+1)*(ISG-1)+2

* fill the begin track parameters from the seed
        ZF = Q(JSD+5)
        XF = Q(JSD+6)
        YF = Q(JSD+7)
        TXF= Q(JSD+8)
        TYF= Q(JSD+9)

        Q(JSG+JRSEG_ZF)  = Q(JSD+5)
        Q(JSG+JRSEG_XF)  = Q(JSD+6)
        Q(JSG+JRSEG_YF)  = Q(JSD+7)
        Q(JSG+JRSEG_TXF) = Q(JSD+8)
        Q(JSG+JRSEG_TYF) = Q(JSD+9)
        Q(JSG+JRSEG_PF)  = 1./Q(JSD+4)
        DO I=1,5
          DO J=I,5
            IF(I.LT.5.AND.J.LT.5) THEN
              IJ=4*I+J+5
              Q(JSG+JRSEG_CVF+matrix_pack(I,J)-1)=Q(JSD+IJ)
            ELSE
              Q(JSG+JRSEG_CVF+matrix_pack(I,J)-1)=0.
            ENDIF
          ENDDO
        ENDDO

* fill the track parameters in the end from the branch
        Q(JSG+JRSEG_ZE)  = Q(JT+23)
        Q(JSG+JRSEG_XE)  = Q(JT+24)
        Q(JSG+JRSEG_YE)  = Q(JT+25)
        Q(JSG+JRSEG_TXE) = Q(JT+26)
        Q(JSG+JRSEG_TYE) = Q(JT+27)
        Q(JSG+JRSEG_PE)  = 1./Q(JSD+4)

        DO I=1,5
          DO J=I,5
            IF(I.LT.5.AND.J.LT.5) THEN
              IJ=4*I+J+23
              Q(JSG+JRSEG_CVE+matrix_pack(I,J)-1)=Q(JT+IJ)
            ELSE
              Q(JSG+JRSEG_CVE+matrix_pack(I,J)-1)=0.
            ENDIF
          ENDDO
        ENDDO

         Q(JSG+JRSEG_CHI) = Q(JT+22)
        IQ(JSG+JRSEG_FIT) = 0
        IQ(JSG+JRSEG_CMP) = rsegc_muon
 
* relations to hits
      DO 20 I=1,NHT
        NH =IHT(I)
        JH =JTMP9+IQ(JTMP9+1)*(NH-1)+2
        IHB=IQ(JH+1)          
        CALL MMBREL(JRSHI,ISG,IHB)   ! #segment - #hitb
 20   CONTINUE

* relation to MC track
      MCT=IQ(JSD+37)
      IF(MCT.GT.0) CALL MMBREL(JRSMT,ISG,MCT)   ! #segment - #MCtrack

* relation to the parent segment
      ISGP=IQ(JSD+3)
      CALL MMBREL(JRSRS,ISGP,ISG)   ! #segment - #segment parent
 
* book RHIT if it is not booked
      IF(JRHIT.LE.0) THEN
        CALL MMBOOK(JRHIT,0)
        IF(JRHIT.LE.0) GOTO 999
      ENDIF
      IF(IQ(JRHIT+1).LE.0) GOTO 999
*
* fill RHIT
      DO 30 I=1,NHT
        NH =IHT(I)
        JH =JTMP9+IQ(JTMP9+1)*(NH-1)+2
        IHB=IQ(JH+1)          
        Z  = Q(JH+6)          
* add one raw 
        CALL MMBOOK(JRHIT,1)
* fill the raw
        IRH=IQ(JRHIT+2)
        JRH=JRHIT+IQ(JRHIT+1)*(IRH-1)+2

        Q(JRH+JRHIT_X) = XF+TXF*(Z-ZF)
        Q(JRH+JRHIT_Y) = YF+TYF*(Z-ZF)
        Q(JRH+JRHIT_TX) = TXF
        Q(JRH+JRHIT_TY) = TYF
        Q(JRH+JRHIT_P) = 0.
        Q(JRH+JRHIT_Q) = 0.
        IQ(JRH+JRHIT_RTRA) = 0
* relation "track segment" - "fit.hit"
        CALL MMBREL(JRSRH,ISG,IRH)   ! #segment - #fit.hit
* relation "fitted hit" - "measured hit"
        CALL MMBREL(JHIRH,IHB,IRH)   ! #meas.hit - #fit.hit
 30   CONTINUE
 
 100  CONTINUE
*
 999  CONTINUE
      RETURN
      END









