*-- Author :    Rainer Mankel   29/11/95

      subroutine distyle()

*     **** set style parameters in /zgrafl/
*     **** called by KUIP !
      implicit none

#include "pris/zgraf.fi"
#include "arte/ArteFlag.fi"
      character*10 c, chopt
      integer nch
      real widmc, widrc

      logical set, unset, toggle, void, reframe
      set(c)   = c.eq.'T'.or.c.eq.'Y'.or.c.eq.'1'
      unset(c) = c.eq.'F'.or.c.eq.'N'.or.c.eq.'0'
      toggle(c) = c.eq.'X'
      void(c)  = c.eq.' '

      if (prisinit.eq.0) call dicinit()

      reframe = .false.

      call kugetc(c,nch)  ! get MCMIMP
      if (set(c)) then
         lmcmimpzg = .true.
      elseif (unset(c)) then
         lmcmimpzg = .false.
      elseif (toggle(c)) then
         lmcmimpzg = .not.lmcmimpzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid MCMIMP parameter ', c
      endif

      call kugetc(c,nch)  ! get RCRHIT
      if (set(c)) then
         lrcrhitzg = .true.
      elseif (unset(c)) then
         lrcrhitzg = .false.
      elseif (toggle(c)) then
         lrcrhitzg = .not.lrcrhitzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid RCRHIT parameter ', c
      endif

      call kugetc(c,nch)  ! get CROSS
      if (set(c)) then
         lcrosszg = .true.
      elseif (unset(c)) then
         lcrosszg = .false.
      elseif (toggle(c)) then
         lcrosszg = .not.lcrosszg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid CROSS parameter ', c
      endif

      call kugetc(c,nch)  ! get OPAQUE
      if (set(c)) then
         lopaquezg = .true.
      elseif (unset(c)) then
         lopaquezg = .false.
      elseif (toggle(c)) then
         lopaquezg = .not.lopaquezg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid OPAQUE parameter ', c
      endif

      call kugetc(c,nch)  ! get HEADER
      if (set(c)) then
         lheaderzg = .true.
         reframe = .true.
      elseif (unset(c)) then
         lheaderzg = .false.
         reframe = .true.
      elseif (toggle(c)) then
         lheaderzg = .not.lheaderzg
         reframe = .true.
      elseif (void(c)) then
      else
         print *,' () distyle: invalid HEADER parameter ', c
      endif

      call kugetc(c,nch)  ! get FRAME
      if (set(c)) then
         lframezg = .true.
      elseif (unset(c)) then
         lframezg = .false.
      elseif (toggle(c)) then
         lframezg = .not.lframezg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid FRAME parameter ', c
      endif

      call kugetc(c,nch)  ! get AXIS
      if (set(c)) then
         laxiszg = .true.
         reframe = .true.
      elseif (unset(c)) then
         laxiszg = .false.
         reframe = .true.
      elseif (toggle(c)) then
         laxiszg = .not.laxiszg
         reframe = .true.
      elseif (void(c)) then
      else
         print *,' () distyle: invalid AXIS parameter ', c
      endif

      call kugetc(c,nch)  ! get TYPE
      if (set(c)) then
         ltypezg = .true.
      elseif (unset(c)) then
         ltypezg = .false.
      elseif (toggle(c)) then
         ltypezg = .not.ltypezg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid TYPE parameter ', c
      endif

      call kugetc(c,nch)  ! get STEREO
      if (set(c)) then
         lstereozg = .true.
      elseif (unset(c)) then
         lstereozg = .false.
      elseif (toggle(c)) then
         lstereozg = .not.lstereozg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid STEREO parameter ', c
      endif

      call kugetc(c,nch)  ! get BACK
      if (set(c)) then
         lbackzg = .true.
      elseif (unset(c)) then
         lbackzg = .false.
      elseif (toggle(c)) then
         lbackzg = .not.lbackzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid BACKGROUND parameter ', c
      endif

      call kugetc(c,nch)  ! get MC
      if (set(c)) then
         lmczg = .true.
      elseif (unset(c)) then
         lmczg = .false.
      elseif (toggle(c)) then
         lmczg = .not.lmczg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid MC parameter ', c
      endif

      call kugetc(c,nch)  ! get B0
      if (set(c)) then
         lb0zg = .true.
      elseif (unset(c)) then
         lb0zg = .false.
      elseif (toggle(c)) then
         lb0zg = .not.lb0zg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid B0 parameter ', c
      endif

      call kugetc(c,nch)  ! get RC
      if (set(c)) then
         lrczg = .true.
      elseif (unset(c)) then
         lrczg = .false.
      elseif (toggle(c)) then
         lrczg = .not.lrczg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid RC parameter ', c
      endif

      call kugetc(c,nch)  ! get MIMP
      if (set(c)) then
         lmimpzg = .true.
      elseif (unset(c)) then
         lmimpzg = .false.
      elseif (toggle(c)) then
         lmimpzg = .not.lmimpzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid MIMP parameter ', c
      endif

      call kugetc(c,nch)  ! get QUANT
      if (set(c)) then
         lquantzg = .true.
      elseif (unset(c)) then
         lquantzg = .false.
      elseif (toggle(c)) then
         lquantzg = .not.lquantzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid QUANT parameter ', c
      endif

      call kugetc(c,nch)  ! get WIRE
      if (set(c)) then
         lwirezg = .true.
      elseif (unset(c)) then
         lwirezg = .false.
      elseif (toggle(c)) then
         lwirezg = .not.lwirezg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid WIRE parameter ', c
      endif

      call kugetc(c,nch)  ! get ASPECT
      if (set(c)) then
         laspectzg = .true.
         reframe = .true.
      elseif (unset(c)) then
         laspectzg = .false.
         reframe = .true.
      elseif (toggle(c)) then
         laspectzg = .not.laspectzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid ASPECT parameter ', c
      endif

      call kugetc(c,nch)  ! get WALL
      if (set(c)) then
         lwallzg = .true.
      elseif (unset(c)) then
         lwallzg = .false.
      elseif (toggle(c)) then
         lwallzg = .not.lwallzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid WALL parameter ', c
      endif

      call kugetc(c,nch)  ! get SENS
      if (set(c)) then
         lsenszg = .true.
      elseif (unset(c)) then
         lsenszg = .false.
      elseif (toggle(c)) then
         lsenszg = .not.lsenszg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid SENS parameter ', c
      endif

      call kugetc(c,nch)  ! get MVER
      if (set(c)) then
         lmverzg = .true.
      elseif (unset(c)) then
         lmverzg = .false.
      elseif (toggle(c)) then
         lmverzg = .not.lmverzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid WALL parameter ', c
      endif

      call kugetc(c,nch)  ! get PLAN
      if (set(c)) then
         lplanzg = .true.
      elseif (unset(c)) then
         lplanzg = .false.
      elseif (toggle(c)) then
         lplanzg = .not.lplanzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid PLAN parameter ', c
      endif

      call kugetc(c,nch)  ! get SCLIP
      if (set(c)) then
         lsclipzg = .true.
      elseif (unset(c)) then
         lsclipzg = .false.
      elseif (toggle(c)) then
         lsclipzg = .not.lsclipzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid SCLIP parameter ', c
      endif

      call kugetc(c,nch)  ! get NEUT
      if (set(c)) then
         lneutzg = .true.
      elseif (unset(c)) then
         lneutzg = .false.
      elseif (toggle(c)) then
         lneutzg = .not.lneutzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid NEUT parameter ', c
      endif

      call kugetc(c,nch)  ! get CHAIN
      if (set(c)) then
         lchainzg = .true.
      elseif (unset(c)) then
         lchainzg = .false.
      elseif (toggle(c)) then
         lchainzg = .not.lchainzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid CHAIN parameter ', c
      endif

      call kugetc(c,nch)  ! get EVER
      if (set(c)) then
         leverzg = .true.
      elseif (unset(c)) then
         leverzg = .false.
      elseif (toggle(c)) then
         leverzg = .not.leverzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid EVER parameter ', c
      endif

      call kugetc(c,nch)  ! get MAGNET
      if (set(c)) then
         lmagnetzg = .true.
      elseif (unset(c)) then
         lmagnetzg = .false.
      elseif (toggle(c)) then
         lmagnetzg = .not.lmagnetzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid MAGNET parameter ', c
      endif

      call kugetc(c,nch)  ! get RVER
      if (set(c)) then
         lrverzg = .true.
      elseif (unset(c)) then
         lrverzg = .false.
      elseif (toggle(c)) then
         lrverzg = .not.lrverzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid RVER parameter ', c
      endif

      call kugetc(c,nch)  ! get SPLINE
      if (set(c)) then
         lsplinezg = .true.
      elseif (unset(c)) then
         lsplinezg = .false.
      elseif (toggle(c)) then
         lsplinezg = .not.lsplinezg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid SPLINE parameter ', c
      endif

      call kugetc(c,nch)  ! get RSEG
      if (set(c)) then
         lrsegzg = .true.
      elseif (unset(c)) then
         lrsegzg = .false.
      elseif (toggle(c)) then
         lrsegzg = .not.lrsegzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid RSEG parameter ', c
      endif

      call kugetc(c,nch)  ! get CELL
      if (set(c)) then
         lcellzg = .true.
      elseif (unset(c)) then
         lcellzg = .false.
      elseif (toggle(c)) then
         lcellzg = .not.lcellzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid CELL parameter ', c
      endif

      call kugetc(c,nch)  ! get TARG
      if (set(c)) then
         ltargzg = .true.
      elseif (unset(c)) then
         ltargzg = .false.
      elseif (toggle(c)) then
         ltargzg = .not.ltargzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid TARG parameter ', c
      endif

      call kugetc(c,nch)  ! get RPNT
      if (set(c)) then
         lrpntzg = .true.
      elseif (unset(c)) then
         lrpntzg = .false.
      elseif (toggle(c)) then
         lrpntzg = .not.lrpntzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid RPNT parameter ', c
      endif

      call kugetc(c,nch)  ! get RCCL
      if (set(c)) then
         lrcclzg = .true.
      elseif (unset(c)) then
         lrcclzg = .false.
      elseif (toggle(c)) then
         lrcclzg = .not.lrcclzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid RCCL parameter ', c
      endif

      call kugetc(c,nch)  ! get GCAL
      if (set(c)) then
         lgcalzg = .true.
      elseif (unset(c)) then
         lgcalzg = .false.
      elseif (toggle(c)) then
         lgcalzg = .not.lgcalzg
      elseif (void(c)) then
      else
         print *,' () distyle: invalid GCAL parameter ', c
      endif







      call kugetr(widmc)
      if (widmc.gt.0.1) widmczg = widmc

      call kugetr(widrc)
      if (widrc.gt.0.1) widrczg = widrc

      call kugetc(chopt,nch) ! get options

      if (reframe.and.index(chopt,'N').eq.0) 
     +     call difrset()       ! recalculate frame

      if (index(chopt,'L').gt.0) then
         print '(34(a8,a30,2x,l1/),2(a8,a30,2x,f6.1/))',
     +        'MTMIMP', 'use mimps to draw MC tracks ', lmcmimpzg,
     +        'RTRHIT', 'use rhits to draw RC tracks ', lrcrhitzg,
     +        'CROSS', 'draw crosses at rhit position ', lcrosszg,
     +        'OPAQUE', 'draw opaque planes ', lopaquezg,
     +        'HEADER', 'draw header ', lheaderzg,
     +        'FRAME', 'draw frame ', lframezg,
     +        'AXIS', 'draw axes ', laxiszg,
     +        'TYPE', 'draw particle name string ', ltypezg,
     +        'STEREO','show stereo planes ', lstereozg,
     +        'BACKGROUND','use background colour ' , lbackzg,
     +        'MC','show MC tracks ' , lmczg,
     +        'B0','restrict to golden B0 ' , lb0zg,
     +        'RC','show RC tracks ' , lrczg,
     +        'MIMPS','show MIMPS ' , lmimpzg,
     +        'QUANT','show QUANTITY ' , lquantzg,
     +        'WIRE','show wires/hits ' , lwirezg,
     +        'ASPECT','force conserved aspect ratio ' , laspectzg,
     +        'WALL','draw walls ' , lwallzg,
     +        'SENS','draw sensitive plane areas ',lsenszg,
     +        'MVER','draw MC vertices ' , lmverzg,
     +        'PLAN','draw planes ' , lplanzg,
     +        'SCLIP','apply software clipping ' , lsclipzg,
     +        'NEUT','show neutral MC particles ' , lneutzg,
     +        'CHAIN','show whole decay chain ' , lchainzg,
     +        'EVER','show end vertices ' ,  leverzg,
     +        'MAGNET','show magnet ' ,  lmagnetzg,
     +        'RVER',  'show rver ' ,  lrverzg,
     +        'SPLINE',  'show spline ' ,  lsplinezg,
     +        'RSEG',  'show rseg ' ,  lrsegzg,
     +        'CELL',  'show cell ' ,  lcellzg,
     +        'TARG','show target ' ,  ltargzg,
     +        'RPNT','show reconstr points ' ,  lrpntzg,
     +        'RCCL','show reconstr clusters ' ,  lrcclzg,
     +        'GCAL','show ECAL cells ' ,  lgcalzg,
     +        'WIDMC','width factor of MC lines', widmczg,
     +        'WIDRC','width factor of RC lines', widrczg
      endif

      end
