// 
//  Author:  Rainer Mankel                     Created:  23-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/DomLay.hh"
#include "rang/DomWin.hh"

extern "C" {
  void rgdlwbord_(rangerDomLay*& dl,float& xmin,float& xmax,
		  float& ymin,float& ymax) {
    if (dl) {
      xmin = dl->win()->xmin();
      xmax = dl->win()->xmax();
      ymin = dl->win()->ymin();
      ymax = dl->win()->ymax();
//       cout << "rgdlwbord: xmin=" << xmin << " xmax=" << xmax << endl;
    }
    else {
      cout << "rgdlwbord: invalid dl=" << dl << endl;
    }
  }
}



    



