
// ********************************************************************
//
//  Routine:      rc99AParticleID
//  Author:       T.Oest/D.Samtleben
//
//  Description:  stand alone reconstruction
//
//  Modification:
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

#include "reco/rc99Areco.hh"

static int recoID  = 0;

//********************************************************************
// rcParticleID
//********************************************************************
  int rc99AParticleID() {

//===================================================================
//  RICH particle ID for electrons
//===================================================================

    //  if (recoID)     ;


//===================================================================
//  flag for particle ID
//===================================================================

    return 0;

  }


/************************************************************************
* KAPID
*
* called from  KUIP
***********************************************************************/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "arte/Arte.hh"

extern "C" void kugetc_( char*, int *, int );


extern "C" void kapid_() {   

//---------------------------------------------------------------
//   read in subdetector
//---------------------------------------------------------------

  int len;        
  int len1 = 4;
  char input[7];
  kugetc_(input, &len, len1);

  char *subdetector;
  subdetector  = (char *) malloc(len+1);
  sprintf(subdetector  ,"%s", input);

  for(int i=0; i<len; i++) subdetector[i] = toupper(subdetector[i]);

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  len1 = 3;
  kugetc_(input, &len, len1);

  char *status;
  status  = (char *) malloc(len+1);
  sprintf(status  ,"%s", input);

  if(len>0) for(int i=0; i<len; i++) status[i] = toupper(input[i]);

//---------------------------------------------------------------
//   set reconstruction status
//---------------------------------------------------------------

  int istatus = !strncmp(status,"ON",2);

  if (!strncmp(subdetector,"RICH"   ,4)) recoID     = istatus;

  if (!strncmp(subdetector,"ALL" ,3)) {
     recoID      = istatus;
  };

};
