// ********************************************************************
//
//  Routine:      rc99Ainit
//
//  Author:       T.Oest/D.Samtleben
//
//  Description:  reconstruction initialization
//
//  Modification:
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "reco/rc99Areco.hh"
#include "marple/marple.hh"

extern "C" void tfinit_();
//void unpackgede();

//*****************************************************************
// function
//*****************************************************************

void rc99Ainit() {

//==================================================================
// initilisation of stand alone reconstruction software
//
//   1. VDS
//   2. ECAL
//   3. ranger 
//   4. MARPLE
//==================================================================

  //  unpackgede();

  rc99AiVDS();
  rc99AiECAL();
  tfinit_();
  marpleinit_();

}
