#include "wax/OTrComponent.hh"

#ifdef __OTR_CLASSDEF__
ClassImp(OTrComponent) ;
ClassImp(OTrDaqComponent) ;
ClassImp(OTrDetectorComponent) ;
#endif

OTrComponent::OTrComponent() : fId(0) {} ;
OTrComponent::OTrComponent(ComponentId_t id) : fId(id) {} ;
OTrComponent::~OTrComponent() {} ;
void OTrComponent::Dump(ostream& os) const {
  os << "Id: " << GetId() << endl ; } ;

OTrDaqComponent::OTrDaqComponent() : OTrComponent() {} ;
OTrDaqComponent::OTrDaqComponent(ComponentId_t id) : OTrComponent(id) {} ;
OTrDaqComponent::~OTrDaqComponent() {} ;

OTrDaq* OTrDaqComponent::fgDaq = 0 ;
void OTrDaqComponent::Reset(bool) {} ;
void OTrDaqComponent::ProcessEvent(unsigned char* fedDataBuffer) {} ;

OTrDetectorComponent::OTrDetectorComponent() : OTrComponent() {} ;
OTrDetectorComponent::OTrDetectorComponent(ComponentId_t id) : OTrComponent(id) {} ;
OTrDetectorComponent::~OTrDetectorComponent() {} ;
OTrDetector* OTrDetectorComponent::fgDetector = 0 ;

